(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/bidi'), require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/cdk/keycodes'), require('rxjs/operators'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@bmat/angular/forms/bm-slider', ['exports', '@angular/core', '@angular/cdk/bidi', '@angular/cdk/overlay', '@angular/common', '@angular/cdk/keycodes', 'rxjs/operators', 'rxjs'], factory) :
    (global = global || self, factory((global.bmat = global.bmat || {}, global.bmat.angular = global.bmat.angular || {}, global.bmat.angular.forms = global.bmat.angular.forms || {}, global.bmat.angular.forms['bm-slider'] = {}), global.ng.core, global.ng.cdk.bidi, global.ng.cdk.overlay, global.ng.common, global.ng.cdk.keycodes, global.rxjs.operators, global.rxjs));
}(this, function (exports, core, bidi, overlay, common, keycodes, operators, rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMSliderValueTooltipDirective = /** @class */ (function () {
        function BMSliderValueTooltipDirective(templateRef) {
            this.templateRef = templateRef;
        }
        BMSliderValueTooltipDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bmSliderValueTooltip]',
                    },] }
        ];
        /** @nocollapse */
        BMSliderValueTooltipDirective.ctorParameters = function () { return [
            { type: core.TemplateRef }
        ]; };
        return BMSliderValueTooltipDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Observable Drag. Return relative position without the first
     * container, or body, with position non static.
     * @param {?} mousedownEvent
     * @param {?=} doc
     * @return {?}
     */
    function dragObservable(mousedownEvent, doc) {
        if (doc === void 0) { doc = document; }
        /** @type {?} */
        var container = (/** @type {?} */ (mousedownEvent.target));
        while (container.tagName !== 'BODY' &&
            getComputedStyle(container).getPropertyValue('position') !== 'static') {
            container = (/** @type {?} */ (container.parentElement));
        }
        var _a = container.getBoundingClientRect(), left = _a.left, width = _a.width;
        /** @type {?} */
        var offsetX = mousedownEvent.offsetX;
        /** @type {?} */
        var mouseup = rxjs.fromEvent(doc, 'mouseup');
        /** @type {?} */
        var mousemove = rxjs.fromEvent(doc, 'mousemove');
        return mousemove.pipe(operators.map((/**
         * @param {?} mousemoveEvent
         * @return {?}
         */
        function (mousemoveEvent) {
            mousemoveEvent.preventDefault();
            return Math.min(1, Math.max(0, (mousemoveEvent.clientX - offsetX - left) / width));
        })), operators.takeUntil(mouseup));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Observable Drag. Return relative position without the first
     * container, or body, with position non static.
     * @param {?} mouseenterEvent
     * @param {?=} doc
     * @return {?}
     */
    function mouseoverRelativeCoordinatesObservable(mouseenterEvent, doc) {
        if (doc === void 0) { doc = document; }
        mouseenterEvent.preventDefault();
        /** @type {?} */
        var container = (/** @type {?} */ (mouseenterEvent.target));
        while (container.tagName !== 'BODY' &&
            getComputedStyle(container).getPropertyValue('position') !== 'static') {
            container = (/** @type {?} */ (container.parentElement));
        }
        var _a = container.getBoundingClientRect(), left = _a.left, width = _a.width;
        /** @type {?} */
        var mouseleave = rxjs.fromEvent(container, 'mouseleave');
        /** @type {?} */
        var mousemove = rxjs.fromEvent(doc, 'mousemove');
        return mousemove.pipe(operators.map((/**
         * @param {?} mousemoveEvent
         * @return {?}
         */
        function (mousemoveEvent) {
            mousemoveEvent.preventDefault();
            return Math.min(1, Math.max(0, (mousemoveEvent.clientX - left) / width));
        })), operators.takeUntil(mouseleave), operators.startWith(Math.min(1, Math.max(0, (mouseenterEvent.clientX - left) / width))));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMSliderComponent = /** @class */ (function () {
        function BMSliderComponent(_elementRef, _document, _cdr, _dir) {
            this._elementRef = _elementRef;
            this._document = _document;
            this._cdr = _cdr;
            this._dir = _dir;
            this.min = 0;
            this.tabindex = 0;
            this.role = 'slider';
            this.change = new core.EventEmitter();
            this.dragStart = new core.EventEmitter();
            this.dragEnd = new core.EventEmitter();
            this._isDragging = false;
            this._isOver = false;
        }
        Object.defineProperty(BMSliderComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._value = v;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} v
         * @return {?}
         */
        BMSliderComponent.prototype.writeValue = /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            this.value = v;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BMSliderComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChangeCB = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BMSliderComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouchedCB = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        BMSliderComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        BMSliderComponent.prototype.onMouseenter = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            if (this.disabled) {
                return;
            }
            this._isOver = true;
            mouseoverRelativeCoordinatesObservable($event, this._document).subscribe({
                next: (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    _this.pointerTime = val * (_this.max || 0);
                    /** @type {?} */
                    var overTime = Math.max(0, _this.getRelativeLeft(_this.pointerTime) -
                        _this.getRelativeLeft(_this.value));
                    if (overTime > 0 &&
                        _this._previewBar &&
                        _this._previewBar.nativeElement) {
                        /** @type {?} */
                        var relativeLeft = _this.getRelativeLeft(_this.value);
                        _this._previewBar.nativeElement.style.left = relativeLeft + "px";
                        _this._previewBar.nativeElement.style.width = overTime + "px";
                    }
                    _this._cdr.markForCheck();
                }),
                error: (/**
                 * @return {?}
                 */
                function () {
                    _this._isOver = false;
                }),
                complete: (/**
                 * @return {?}
                 */
                function () {
                    _this._isOver = false;
                    _this._cdr.markForCheck();
                }),
            });
        };
        /**
         * @param {?} e
         * @return {?}
         */
        BMSliderComponent.prototype.onClick = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (!this._isDragging) {
                e.preventDefault();
                var offsetX = e.offsetX;
                var width = this._elementRef.nativeElement.getBoundingClientRect().width;
                /** @type {?} */
                var percent = offsetX / width;
                this.value = percent * (this.max || 0);
                this.change.emit(this.value);
            }
        };
        /**
         * @return {?}
         */
        BMSliderComponent.prototype.onFocusin = /**
         * @return {?}
         */
        function () {
            if (this._onTouchedCB) {
                this._onTouchedCB();
            }
        };
        // tslint:disable-next-line:cyclomatic-complexity
        // tslint:disable-next-line:cyclomatic-complexity
        /**
         * @param {?} e
         * @return {?}
         */
        BMSliderComponent.prototype.onKeydown = 
        // tslint:disable-next-line:cyclomatic-complexity
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this.disabled) {
                return;
            }
            /** @type {?} */
            var emitChanges = false;
            if (this.max) {
                /** @type {?} */
                var smallStep = (this.max || 1) / 100;
                switch (e.keyCode) {
                    case keycodes.PAGE_DOWN: {
                        e.preventDefault();
                        this._value = Math.max(0, this._value - 10 * smallStep);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.PAGE_UP: {
                        e.preventDefault();
                        this._value = Math.min(this.max, this._value + 10 * smallStep);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.DOWN_ARROW: {
                        e.preventDefault();
                        this._value = Math.max(0, this._value - smallStep);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.UP_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(this.max, this._value + smallStep);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.LEFT_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(Math.max(0, this._value +
                            (this._dir.value === 'ltr' ? -smallStep : smallStep)), this.max);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.RIGHT_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(Math.max(0, this._value +
                            (this._dir.value === 'ltr' ? smallStep : -smallStep)), this.max);
                        emitChanges = true;
                        break;
                    }
                    default:
                }
            }
            if (emitChanges) {
                if (this._onChangeCB) {
                    this._onChangeCB(this.value);
                }
                this.change.emit(this.value);
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        BMSliderComponent.prototype.getRelativeLeft = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this._elementRef.nativeElement && value && this.max) {
                var width = this._elementRef.nativeElement.getBoundingClientRect().width;
                /** @type {?} */
                var relative = value / (this.max - this.min);
                return relative * width;
            }
            return 0;
        };
        /**
         * @return {?}
         */
        BMSliderComponent.prototype.showThumb = /**
         * @return {?}
         */
        function () {
            return this._isDragging || this._isOver;
        };
        /**
         * @return {?}
         */
        BMSliderComponent.prototype.showPreviewBar = /**
         * @return {?}
         */
        function () {
            return this._isOver && !this._isDragging;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        BMSliderComponent.prototype.onThumbMousedown = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            if (this.disabled) {
                return;
            }
            this._cdr.detach();
            this._isDragging = true;
            if (this._onTouchedCB) {
                this._onTouchedCB();
            }
            this.dragStart.emit();
            /** @type {?} */
            var dragObservable$ = dragObservable($event, this._document).pipe(operators.share());
            // The two observables with different throttles target components
            // that should update at different rates. The bounced targets the
            // the time tooltip, while the non bounced targets the dragged thumb
            // and bars.
            dragObservable$
                .pipe(operators.debounceTime(15))
                .subscribe((/**
             * @return {?}
             */
            function () { return _this._cdr.detectChanges(); }));
            dragObservable$.subscribe({
                next: (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    _this._value = val * (_this.max || 0);
                    /** @type {?} */
                    var relativeLeft = _this.getRelativeLeft(_this.value);
                    ((/** @type {?} */ ($event.target))).style.left = relativeLeft + "px";
                    if (_this._doneBar && _this._doneBar.nativeElement) {
                        _this._doneBar.nativeElement.style.width = relativeLeft + "px";
                    }
                    if (_this._onChangeCB) {
                        _this._onChangeCB(Math.min(Math.max(_this.min, _this.value), _this.max));
                    }
                    _this.change.emit(_this.value);
                }),
                error: (/**
                 * @return {?}
                 */
                function () {
                    _this._cdr.reattach();
                }),
                complete: (/**
                 * @return {?}
                 */
                function () {
                    _this._cdr.reattach();
                    _this.dragEnd.emit();
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this._isDragging = false;
                    }), 10);
                }),
            });
        };
        BMSliderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-slider',
                        template: "<span\n  *ngIf=\"showPreviewBar()\"\n  #previewBar\n  class=\"bm-slider__bar bm-slider__bar--preview\"\n></span>\n<span\n  #doneBar\n  class=\"bm-slider__bar bm-slider__bar--done\"\n  [ngStyle]=\"{ 'width.px': getRelativeLeft(value) }\"\n></span>\n<span\n  *ngIf=\"showThumb()\"\n  #thumb\n  class=\"bm-slider-thumb\"\n  [ngStyle]=\"{ 'left.px': getRelativeLeft(value), 'margin-left.em': -0.5 }\"\n  (mousedown)=\"onThumbMousedown($event)\"\n></span>\n<ng-content></ng-content>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{height:.5em;border-radius:.4em;display:inline-block;background-color:var(--secondary-color,#bcbcbc);max-width:100%;min-width:var(--bm-slider-min--width,200px);position:relative}:host:focus{outline:solid var(--anchor-color,#4399fd) 2px}:host(.bm-slider--disabled){opacity:.5}.bm-slider__bar{height:.5em;border-radius:.4em;display:inline-block;position:absolute}.bm-slider__bar--done{background-color:var(--header-background-color,#3e71ad)}.bm-slider__bar--preview{background-color:var(--secondary-color-hover,#959494)}.bm-slider-thumb{position:absolute;background-color:var(--header-background-color,#3e71ad);border-radius:50%;display:inline-block;height:1em;width:1em;top:-.25em}.bm-slider-tooltip{display:inline-block;background-color:rgba(0,0,0,.7);border:1px solid #000;border-radius:3px;padding:.25em .5em;color:#fff;font-size:smaller}"]
                    }] }
        ];
        /** @nocollapse */
        BMSliderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
            { type: core.ChangeDetectorRef },
            { type: bidi.Directionality }
        ]; };
        BMSliderComponent.propDecorators = {
            max: [{ type: core.HostBinding, args: ['attr.aria-valuemax',] }, { type: core.Input }],
            value: [{ type: core.HostBinding, args: ['attr.aria-valuenow',] }, { type: core.Input }],
            min: [{ type: core.HostBinding, args: ['attr.aria-valuemin',] }, { type: core.Input }],
            tabindex: [{ type: core.HostBinding, args: ['attr.tabindex',] }, { type: core.Input }],
            disabled: [{ type: core.Input }, { type: core.HostBinding, args: ['attr.aria-disabled',] }, { type: core.HostBinding, args: ['class.bm-slider--disabled',] }],
            role: [{ type: core.HostBinding, args: ['attr.role',] }],
            change: [{ type: core.Output }],
            dragStart: [{ type: core.Output }],
            dragEnd: [{ type: core.Output }],
            _doneBar: [{ type: core.ViewChild, args: ['doneBar', { read: core.ElementRef, static: true },] }],
            _previewBar: [{ type: core.ViewChild, args: ['previewBar', { read: core.ElementRef, static: false },] }],
            onMouseenter: [{ type: core.HostListener, args: ['mouseenter', ['$event'],] }],
            onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }],
            onFocusin: [{ type: core.HostListener, args: ['focusin',] }],
            onKeydown: [{ type: core.HostListener, args: ['keydown', ['$event'],] }]
        };
        return BMSliderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMSliderComponentModule = /** @class */ (function () {
        function BMSliderComponentModule() {
        }
        BMSliderComponentModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [bidi.BidiModule, common.CommonModule, overlay.OverlayModule],
                        declarations: [BMSliderValueTooltipDirective, BMSliderComponent],
                        exports: [BMSliderComponent, BMSliderValueTooltipDirective],
                    },] }
        ];
        return BMSliderComponentModule;
    }());

    exports.BMSliderComponent = BMSliderComponent;
    exports.BMSliderComponentModule = BMSliderComponentModule;
    exports.BMSliderValueTooltipDirective = BMSliderValueTooltipDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bmat-angular-forms-bm-slider.umd.js.map
