(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@bmat/angular/forms/bm-switch-checkbox', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = global || self, factory((global.bmat = global.bmat || {}, global.bmat.angular = global.bmat.angular || {}, global.bmat.angular.forms = global.bmat.angular.forms || {}, global.bmat.angular.forms['bm-switch-checkbox'] = {}), global.ng.core, global.ng.forms, global.ng.common));
}(this, function (exports, core, forms, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMSwitchCheckboxComponent = /** @class */ (function () {
        function BMSwitchCheckboxComponent(_changeDetectorRef, _renderer) {
            this._changeDetectorRef = _changeDetectorRef;
            this._renderer = _renderer;
            this.tabIndex = 0;
            this.switchChange = new core.EventEmitter();
        }
        Object.defineProperty(BMSwitchCheckboxComponent.prototype, "isFocused", {
            get: /**
             * @return {?}
             */
            function () {
                return this._focused;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BMSwitchCheckboxComponent.prototype, "checked", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.input && this.input.nativeElement) {
                    return this.input.nativeElement.checked;
                }
                return false;
            },
            set: /**
             * @param {?} checked
             * @return {?}
             */
            function (checked) {
                this._renderer.setProperty(this.input.nativeElement, 'checked', checked);
            },
            enumerable: true,
            configurable: true
        });
        // Focus Blur Handle
        // Focus Blur Handle
        /**
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.inputFocus = 
        // Focus Blur Handle
        /**
         * @return {?}
         */
        function () {
            this._focused = true;
        };
        /**
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.inputBlur = /**
         * @return {?}
         */
        function () {
            this._focused = false;
            if (this._onTouched) {
                this._onTouched();
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.checked = value;
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._propagateChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.inputChange = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this._propagateChange) {
                this._propagateChange(((/** @type {?} */ (event.target))).checked);
            }
            this.switchChange.emit({
                checked: ((/** @type {?} */ (event.target))).checked,
                source: this,
            });
        };
        /**
         * @return {?}
         */
        BMSwitchCheckboxComponent.prototype.focus = /**
         * @return {?}
         */
        function () {
            if (this.input && this.input.nativeElement) {
                this.input.nativeElement.focus();
            }
        };
        BMSwitchCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-switch-checkbox',
                        template: "<label class=\"bm-switch-checkbox__label-container\">\n  <input\n    #input\n    type=\"checkbox\"\n    class=\"bm-switch-checkbox__checkbox\"\n    (blur)=\"inputBlur()\"\n    (change)=\"inputChange($event)\"\n    (focus)=\"inputFocus()\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledby\"\n    [disabled]=\"disabled\"\n    [name]=\"name\"\n    [readonly]=\"readonly\"\n    [required]=\"required\"\n    [tabIndex]=\"tabIndex\"\n  />\n  <span\n    class=\"bm-switch-checkbox__container\"\n    [ngClass]=\"{\n      'bm-switch-checkbox__container--checked': checked,\n      'bm-switch-checkbox__container--disabled': disabled\n    }\"\n  >\n    <span\n      class=\"bm-switch-checkbox__thumb\"\n      [ngClass]=\"{ 'bm-switch-checkbox__thumb--checked': checked }\"\n    ></span>\n  </span>\n  <span class=\"bm-switch-checkbox__label\"><ng-content></ng-content></span>\n</label>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                // tslint:disable-next-line:no-forward-ref
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return BMSwitchCheckboxComponent; })),
                                multi: true,
                            },
                        ],
                        styles: ["bm-switch-checkbox{border:1px solid transparent;border-radius:.2em;display:inline-block}.bm-switch-checkbox__checkbox{border:0;clip:rect(0 0 0 0);height:1px;margin:-1px;overflow:hidden;padding:0;position:absolute;text-transform:none;width:1px}.bm-switch-checkbox--focused,.bm-switch-checkbox--focused .bm-switch-checkbox-container{border-color:var(--anchor-color,#4399fd)}.bm-switch-checkbox__container{align-items:center;background-color:var(--bm-switch-unchecked-color,#dadfea);border-color:var(--bm-switch-unchecked-color,#dadfea);border-radius:.2em;border:1px solid var(--secondary-color,#dadfea);display:inline-flex;height:1.5em;overflow:hidden;position:relative;transition:.2s ease-in;vertical-align:middle;width:3em}.bm-switch-checkbox__container--checked{background-color:var(--bm-switch-checked-color,#4dbd74);border-color:var(--bm-switch-checked-border-color,#3a9d5d)}.bm-switch-checkbox__container--disabled{opacity:.6;cursor:not-allowed}.bm-switch-checkbox__thumb{background-color:#fff;border-radius:.2em;border:1px solid var(--secondary-color,#bcbcbc);bottom:.1em;display:inline-block;margin:0 .1em;position:absolute;top:.1em;-webkit-transform:translateX(0);transform:translateX(0);transition:transform .2s ease-in;transition:transform .2s ease-in,-webkit-transform .2s ease-in;vertical-align:middle;width:calc(1.5em - .2em)}.bm-switch-checkbox__thumb::after,.bm-switch-checkbox__thumb::before{align-items:center;bottom:0;display:flex;font-size:.6em;font-weight:600;position:absolute;top:0}.bm-switch-checkbox__thumb::before{color:#fff;content:var(--switch-checked-label, \"Y\");left:-1.6em}.bm-switch-checkbox__thumb::after{color:#80838a;content:var(--switch-unchecked-label, \"N\");right:-1.6em}.bm-switch-checkbox__thumb--checked{border-color:var(--bm-switch-checked-border-color,#3a9d5d);-webkit-transform:translateX(100%);transform:translateX(100%)}.bm-switch-checkbox__tick-path{stroke:var(--bm-checkbox-path-color,#4399fd);stroke-width:.2em;vertical-align:middle}"]
                    }] }
        ];
        /** @nocollapse */
        BMSwitchCheckboxComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef },
            { type: core.Renderer2 }
        ]; };
        BMSwitchCheckboxComponent.propDecorators = {
            input: [{ type: core.ViewChild, args: ['input', { static: true },] }],
            isFocused: [{ type: core.HostBinding, args: ['class.bm-switch-checkbox--focused',] }],
            ariaLabel: [{ type: core.Input, args: ['aria-label',] }],
            ariaLabelledby: [{ type: core.Input, args: ['aria-labelledby',] }],
            disabled: [{ type: core.Input }],
            name: [{ type: core.Input }],
            readonly: [{ type: core.Input }],
            required: [{ type: core.Input }],
            tabIndex: [{ type: core.Input }],
            checked: [{ type: core.Input }],
            switchChange: [{ type: core.Output }]
        };
        return BMSwitchCheckboxComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMSwitchCheckboxModule = /** @class */ (function () {
        function BMSwitchCheckboxModule() {
        }
        BMSwitchCheckboxModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [BMSwitchCheckboxComponent],
                        exports: [BMSwitchCheckboxComponent],
                    },] }
        ];
        return BMSwitchCheckboxModule;
    }());

    exports.BMSwitchCheckboxComponent = BMSwitchCheckboxComponent;
    exports.BMSwitchCheckboxModule = BMSwitchCheckboxModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bmat-angular-forms-bm-switch-checkbox.umd.js.map
