(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/portal'), require('@angular/cdk/bidi'), require('@angular/cdk/keycodes')) :
    typeof define === 'function' && define.amd ? define('@bmat/angular/media-players', ['exports', '@angular/cdk/overlay', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/cdk/portal', '@angular/cdk/bidi', '@angular/cdk/keycodes'], factory) :
    (global = global || self, factory((global.bmat = global.bmat || {}, global.bmat.angular = global.bmat.angular || {}, global.bmat.angular['media-players'] = {}), global.ng.cdk.overlay, global.ng.common, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.cdk.portal, global.ng.cdk.bidi, global.ng.cdk.keycodes));
}(this, function (exports, overlay, common, core, rxjs, operators, portal, bidi, keycodes) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ParseDurationPipe = /** @class */ (function () {
        function ParseDurationPipe() {
        }
        // tslint:disable-next-line:no-any
        // tslint:disable-next-line:no-any
        /**
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        ParseDurationPipe.prototype.transform = 
        // tslint:disable-next-line:no-any
        /**
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        function (value, format) {
            if (format === void 0) { format = 'HH:MM:SS'; }
            /** @type {?} */
            var coerceInteger = Number.parseInt(value, 10);
            if (Number.isNaN(coerceInteger)) {
                return 'N/A';
            }
            /** @type {?} */
            var seconds = coerceInteger % 60;
            /** @type {?} */
            var minutes = Math.floor(coerceInteger / 60) % 60;
            /** @type {?} */
            var hours = Math.floor(coerceInteger / 3600);
            return format
                .split(':')
                .map((/**
             * @param {?} segment
             * @return {?}
             */
            function (segment) {
                var length = segment.length;
                if (length === 0) {
                    throw new TypeError('Invalid format. Empty segment.');
                }
                if (length > 2) {
                    throw new TypeError('Invalid format for segment ' + segment);
                }
                if (segment.length === 2 && segment[0] !== segment[1]) {
                    throw new TypeError('Invalid format for segment ' + segment);
                }
                /** @type {?} */
                var val;
                switch (segment[0]) {
                    case 'H':
                        val = hours.toString();
                        break;
                    case 'M':
                        val = minutes.toString();
                        break;
                    case 'S':
                        val = seconds.toString();
                        break;
                    default:
                        throw new TypeError('Invalid format for segment ' + segment);
                }
                while (val.length < length) {
                    val = '0' + val;
                }
                return val;
            }))
                .join(':');
        };
        ParseDurationPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'bmParseDuration',
                    },] }
        ];
        return ParseDurationPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMMediaOutputComponent = /** @class */ (function () {
        function BMMediaOutputComponent(changeDetectorRef) {
            this.changeDetectorRef = changeDetectorRef;
            this.format = 'MM:SS';
            this.formater = new ParseDurationPipe();
            this.changeDetectorRef.detach();
        }
        Object.defineProperty(BMMediaOutputComponent.prototype, "time", {
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                if (v || v === 0) {
                    this.innerTime = this.formater.transform(Math.max(0, v), this.format);
                    this.changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        BMMediaOutputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-media-output',
                        template: "<span class=\"bm-media-output__content\">{{innerTime}}</span>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        styles: [".bm-media-output__content{padding:0 .4em}"]
                    }] }
        ];
        /** @nocollapse */
        BMMediaOutputComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        BMMediaOutputComponent.propDecorators = {
            format: [{ type: core.Input }],
            time: [{ type: core.Input }]
        };
        return BMMediaOutputComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ProgressBarComponent = /** @class */ (function () {
        function ProgressBarComponent(_cdr) {
            this._cdr = _cdr;
            this.min = 0;
            this.role = 'progressbar';
            this.max = 100;
            /**
             * Sets if the bar should display or not an animation after value changes
             */
            this.staticBar = false;
            this._value = 0;
        }
        Object.defineProperty(ProgressBarComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._value = Math.min(Math.max(0, Number.isNaN(v) ? 0 : v), this.max);
                this.innerWidth = Math.round((10000 * this._value) / this.max) / 100;
                this._cdr.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        ProgressBarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-progress',
                        template: "<div [ngStyle]=\"{ 'width.%': innerWidth }\" class=\"bm-inner-progress-bar\"></div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{height:.5em;border-radius:.4em;background-color:var(--secondary-color-hover,#959494);display:inline-block;max-width:100%;min-width:10em;position:relative}:host(:not([static=true])) .bm-inner-progress-bar{transition:width 2s}.bm-inner-progress-bar{height:.5em;border-radius:.4em;background-color:var(--header-background-color,#3e71ad)}"]
                    }] }
        ];
        /** @nocollapse */
        ProgressBarComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        ProgressBarComponent.propDecorators = {
            min: [{ type: core.HostBinding, args: ['attr.aria-valuemin',] }],
            role: [{ type: core.HostBinding, args: ['attr.role',] }],
            max: [{ type: core.HostBinding, args: ['attr.aria-valuemax',] }, { type: core.Input }],
            value: [{ type: core.HostBinding, args: ['attr.aria-valuenow',] }, { type: core.Input }],
            staticBar: [{ type: core.Input }, { type: core.HostBinding, args: ['attr.static',] }]
        };
        return ProgressBarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMATAudioPlayerComponent = /** @class */ (function () {
        function BMATAudioPlayerComponent(_renderer) {
            this._renderer = _renderer;
            // Forward attributes to audio
            this.autoplay = false;
            this.controls = false;
            this.loop = false;
            this.muted = false;
            this.preload = 'none';
            /**
             * Echo of play HTMLAudioElement event
             */
            this.play = new core.EventEmitter();
            /**
             * Echo of play HTMLAudioElement event
             */
            this.pause = new core.EventEmitter();
            this.isDisabled = true;
            this.isLoading = false;
            this.isPlaying = false;
            this._isMouseDown = false;
            this._progressUpdater$ = rxjs.timer(500, 500).pipe(operators.tap(this.calculateElapsed.bind(this)));
        }
        Object.defineProperty(BMATAudioPlayerComponent.prototype, "src", {
            get: /**
             * @return {?}
             */
            function () {
                return this._src;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._src = v;
                this.isDisabled = !v;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            if (this.progressBar) {
                this.progressBar.value = 0;
                this.progressBar.staticBar = true;
            }
            if (this.mediaOutput) {
                this.mediaOutput.time = 0;
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onButtonMousedown = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            var _this = this;
            event.preventDefault();
            this._mouseDownTime = new Date().getTime();
            this._isMouseDown = true;
            this._playBackTimerSubscription = rxjs.timer(BMATAudioPlayerComponent.HOLD_TIME).subscribe((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var now = new Date().getTime();
                /** @type {?} */
                var deltaTime = now - _this._mouseDownTime;
                if (_this._isMouseDown && deltaTime > BMATAudioPlayerComponent.HOLD_TIME) {
                    _this._renderer.setProperty(_this.audioElement.nativeElement, 'playbackRate', BMATAudioPlayerComponent.ACCELERATED_RATE);
                }
            }));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onloadeddata = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isLoading = true;
        };
        /**
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.ondurationchange = /**
         * @return {?}
         */
        function () {
            this.calculateElapsed();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.oncanplay = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isLoading = false;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onplay = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isPlaying = true;
            this.play.emit();
            if (this.progressBar) {
                this._timerSubscription = this._progressUpdater$.subscribe();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onplaying = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isPlaying = true;
            this.isLoading = false;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onpause = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isPlaying = false;
            this.pause.emit();
            if (this._timerSubscription) {
                this._timerSubscription.unsubscribe();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onwaiting = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            this.isLoading = true;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.onended = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.isPlaying = false;
            event.stopPropagation();
            if (this._timerSubscription) {
                this._timerSubscription.unsubscribe();
                this.progressBar.value = 100;
            }
        };
        /**
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.togglePlay = /**
         * @return {?}
         */
        function () {
            this._renderer.setProperty(this.audioElement.nativeElement, 'playbackRate', 1);
            this._isMouseDown = false;
            /** @type {?} */
            var now = new Date().getTime();
            /** @type {?} */
            var deltaTime = now - this._mouseDownTime;
            this._playBackTimerSubscription.unsubscribe();
            if (deltaTime > BMATAudioPlayerComponent.HOLD_TIME) {
                return;
            }
            if (this.audioElement && this.audioElement.nativeElement) {
                if (this.isPlaying) {
                    this.audioElement.nativeElement.pause();
                }
                else {
                    this.audioElement.nativeElement.play();
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        BMATAudioPlayerComponent.prototype.calculateElapsed = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var nativeAudio = this.audioElement.nativeElement;
            if (this.progressBar) {
                /** @type {?} */
                var currentPosition = Math.min(100, (100 * nativeAudio.currentTime) / nativeAudio.duration);
                this.progressBar.value =
                    !Number.isNaN(currentPosition) && currentPosition > 0
                        ? currentPosition
                        : 0;
            }
            if (this.mediaOutput) {
                this.mediaOutput.time = nativeAudio.currentTime;
            }
        };
        /**
         * Threshold of time to consider a mousedown a hold event.
         */
        BMATAudioPlayerComponent.HOLD_TIME = 200;
        /**
         * Playback rate when playing audio in accelerated mode.
         */
        BMATAudioPlayerComponent.ACCELERATED_RATE = 3;
        BMATAudioPlayerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-audio-player',
                        template: "<audio\n  #audio\n  (canplay)=\"oncanplay($event)\"\n  (durationchange)=\"ondurationchange()\"\n  (ended)=\"onended($event)\"\n  (loadeddata)=\"onloadeddata($event)\"\n  (pause)=\"onpause($event)\"\n  (play)=\"onplay($event)\"\n  (playing)=\"onplaying($event)\"\n  (waiting)=\"onwaiting($event)\"\n  [autoplay]=\"autoplay\"\n  [controls]=\"controls\"\n  [loop]=\"loop\"\n  [muted]=\"muted\"\n  [preload]=\"preload\"\n  [src]=\"src\"\n></audio>\n<button\n  (mousedown)=\"onButtonMousedown($event)\"\n  (mouseup)=\"togglePlay()\"\n  [class.bm-audio-player__button--playing]=\"isPlaying\"\n  [disabled]=\"isDisabled\"\n  aria-label=\"Toggle audio play\"\n  class=\"bm-audio-player__button\"\n  i18n-aria-label\n>\n  <i\n    [ngClass]=\"{\n      'fab fa-youtube': !isLoading,\n      'fas fa-spinner': isLoading\n    }\"\n  ></i>\n</button>\n<ng-content select=\"bm-progress, bm-media-output\"></ng-content>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        // tslint:disable-next-line:use-component-view-encapsulation
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["bm-audio-player{display:inline-flex;align-items:center}.bm-audio-player__button{border:0;background:0 0;padding:0;font-size:2rem;margin:0 .2em;color:var(--secondary-color,#bcbcbc)}.bm-audio-player__button--playing{color:var(--header-background-color,#3e71ad)}.bm-audio-player__button[disabled]{color:var(--header-color,#f8f8f8)}.fa-spinner{-webkit-transform-origin:50% 50%;transform-origin:50% 50%;-webkit-animation:2s linear infinite spin;animation:2s linear infinite spin}@-webkit-keyframes spin{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spin{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}", "bm-progress bm-audio-player,bm-progress bm-media-output{margin:0 .2em}"]
                    }] }
        ];
        /** @nocollapse */
        BMATAudioPlayerComponent.ctorParameters = function () { return [
            { type: core.Renderer2 }
        ]; };
        BMATAudioPlayerComponent.propDecorators = {
            autoplay: [{ type: core.Input }],
            controls: [{ type: core.Input }],
            loop: [{ type: core.Input }],
            muted: [{ type: core.Input }],
            preload: [{ type: core.Input }],
            src: [{ type: core.Input }],
            play: [{ type: core.Output }],
            pause: [{ type: core.Output }],
            audioElement: [{ type: core.ViewChild, args: ['audio', { static: true },] }],
            progressBar: [{ type: core.ContentChild, args: [ProgressBarComponent, { static: true },] }],
            mediaOutput: [{ type: core.ContentChild, args: [BMMediaOutputComponent, { static: true },] }]
        };
        return BMATAudioPlayerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token to provide the
     * @type {?}
     */
    var CONNECTED_PLAYER_CLOSE_REQUEST = new core.InjectionToken('bmat.angular.media-players.connected-player-close-request');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token to provide the
     * @type {?}
     */
    var CONNECTED_PLAYER_SRC = new core.InjectionToken('bmat.angular.media-players.connected-player-src');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token to provide the
     * @type {?}
     */
    var CONNECTED_PLAYER_VOLUME = new core.InjectionToken('bmat.angular.media-players.connected-player-volume');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ConnectedVideoPlayerComponent = /** @class */ (function () {
        function ConnectedVideoPlayerComponent(src, 
        // tslint:disable-next-line:no-any
        _closeRequest, _document, volume, _cdr) {
            this._document = _document;
            this._cdr = _cdr;
            this.autoplay = true;
            this._focusWithin = false;
            this.src = src;
            this._closeRequest = _closeRequest;
            this.volume = volume;
        }
        Object.defineProperty(ConnectedVideoPlayerComponent.prototype, "focusWithin", {
            get: /**
             * @return {?}
             */
            function () {
                return this._focusWithin;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onFocusin = /**
         * @return {?}
         */
        function () {
            this._focusWithin = true;
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onFocusout = /**
         * @return {?}
         */
        function () {
            this._focusWithin = false;
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onDocumentKeydown = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (e.key === 'Escape') {
                this._closeRequest();
            }
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.close = /**
         * @return {?}
         */
        function () {
            this._closeRequest();
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onMediaEnded = /**
         * @return {?}
         */
        function () {
            this._closeRequest();
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.checkAfterVideoElement = /**
         * @return {?}
         */
        function () {
            this._cdr.markForCheck();
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onVideoPlay = /**
         * @return {?}
         */
        function () {
            this.isPlaying = true;
            this._cdr.markForCheck();
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onVideoPause = /**
         * @return {?}
         */
        function () {
            this.isPlaying = false;
            this._cdr.markForCheck();
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.togglePlay = /**
         * @return {?}
         */
        function () {
            if (this._videoElement) {
                if (this._videoElement.nativeElement.paused) {
                    this._videoElement.nativeElement.play();
                }
                else {
                    this._videoElement.nativeElement.pause();
                }
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.onSliderSeek = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (this._videoElement) {
                this._videoElement.nativeElement.currentTime = $event;
            }
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.toggleFullScreen = /**
         * @return {?}
         */
        function () {
            if (this._fullscreenWrapper &&
                this._fullscreenWrapper.nativeElement.requestFullscreen) {
                if (this._document.fullscreenElement) {
                    this._document.exitFullscreen();
                }
                else {
                    this._fullscreenWrapper.nativeElement
                        .requestFullscreen()
                        .catch((/**
                     * @param {?} err
                     * @return {?}
                     */
                    function (err) { return console.error(err); }));
                }
            }
        };
        /**
         * @return {?}
         */
        ConnectedVideoPlayerComponent.prototype.displayFullScreenBtn = /**
         * @return {?}
         */
        function () {
            return (this._fullscreenWrapper &&
                this._fullscreenWrapper.nativeElement.requestFullscreen);
        };
        ConnectedVideoPlayerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-connected-video-player',
                        template: "<div\n  #fullscreenWrapper\n  class=\"bm-connected-video-player-controls__fullscreen-wrap\"\n>\n  <video\n    (durationchange)=\"checkAfterVideoElement()\"\n    (ended)=\"onMediaEnded()\"\n    (pause)=\"onVideoPause()\"\n    (play)=\"onVideoPlay()\"\n    (timeupdate)=\"checkAfterVideoElement()\"\n    [autoplay]=\"autoplay\"\n    [src]=\"src\"\n    [volume]=\"volume\"\n    #videoElement\n    class=\"bm-connected-video-player\"\n    nocontrols\n  ></video>\n  <div\n    class=\"bm-connected-video-player-controls bm-connected-video-player-controls--top\"\n    style=\"text-align: right;\"\n  >\n    <button\n      type=\"button\"\n      class=\"bm-connected-video-player-controls__btn\"\n      i18n-title\n      title=\"Close video\"\n      (click)=\"close()\"\n    >\n      <svg\n        aria-hidden=\"true\"\n        data-prefix=\"fas\"\n        data-icon=\"times\"\n        class=\"bm-connected-video-player__icon\"\n        role=\"img\"\n        xmlns=\"http://www.w3.org/2000/svg\"\n        viewBox=\"0 0 352 512\"\n      >\n        <path\n          fill=\"currentColor\"\n          d=\"M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z\"\n        ></path>\n      </svg>\n    </button>\n  </div>\n  <div\n    class=\"bm-connected-video-player-controls bm-connected-video-player-controls--bottom\"\n  >\n    <bm-media-progress-slider\n      style=\"width: 100%;\"\n      [duration]=\"videoElement.duration\"\n      [value]=\"videoElement.currentTime\"\n      (seek)=\"onSliderSeek($event)\"\n    ></bm-media-progress-slider>\n    <div class=\"bm-connected-video-player-controls__second-level\">\n      <div class=\"bm-connected-video-player-controls__play-ctrl\">\n        <button\n          type=\"button\"\n          class=\"bm-connected-video-player-controls__btn\"\n          i18n-title\n          title=\"Toggle play\"\n          (click)=\"togglePlay()\"\n        >\n          <ng-template #playIcon>\n            <svg\n              aria-hidden=\"true\"\n              data-prefix=\"fas\"\n              data-icon=\"play\"\n              class=\"bm-connected-video-player__icon\"\n              role=\"img\"\n              xmlns=\"http://www.w3.org/2000/svg\"\n              viewBox=\"0 0 448 512\"\n            >\n              <path\n                fill=\"currentColor\"\n                d=\"M424.4 214.7L72.4 6.6C43.8-10.3 0 6.1 0 47.9V464c0 37.5 40.7 60.1 72.4 41.3l352-208c31.4-18.5 31.5-64.1 0-82.6z\"\n              ></path>\n            </svg>\n          </ng-template>\n          <svg\n            *ngIf=\"isPlaying; else playIcon\"\n            aria-hidden=\"true\"\n            data-prefix=\"fas\"\n            data-icon=\"play\"\n            class=\"bm-connected-video-player__icon\"\n            role=\"img\"\n            xmlns=\"http://www.w3.org/2000/svg\"\n            viewBox=\"0 0 448 512\"\n          >\n            <path\n              fill=\"currentColor\"\n              d=\"M144 479H48c-26.5 0-48-21.5-48-48V79c0-26.5 21.5-48 48-48h96c26.5 0 48 21.5 48 48v352c0 26.5-21.5 48-48 48zm304-48V79c0-26.5-21.5-48-48-48h-96c-26.5 0-48 21.5-48 48v352c0 26.5 21.5 48 48 48h96c26.5 0 48-21.5 48-48z\"\n            ></path>\n          </svg>\n        </button>\n        <span class=\"bm-connected-video-player-controls__time-indicator\">{{\n          videoElement.currentTime | bmParseDuration\n        }}</span>\n        /\n        <span class=\"bm-connected-video-player-controls__time-indicator\">{{\n          videoElement.duration | bmParseDuration\n        }}</span>\n      </div>\n      <div>\n        <button\n          *ngIf=\"displayFullScreenBtn()\"\n          type=\"button\"\n          class=\"bm-connected-video-player-controls__btn\"\n          i18n-title\n          title=\"Toggle fullscreen\"\n          (click)=\"toggleFullScreen()\"\n        >\n          <svg\n            aria-hidden=\"true\"\n            data-prefix=\"fas\"\n            data-icon=\"expand-alt\"\n            role=\"img\"\n            xmlns=\"http://www.w3.org/2000/svg\"\n            viewBox=\"0 0 448 512\"\n            class=\"bm-connected-video-player__icon\"\n          >\n            <path\n              fill=\"currentColor\"\n              d=\"M212.686 315.314L120 408l32.922 31.029c15.12 15.12 4.412 40.971-16.97 40.971h-112C10.697 480 0 469.255 0 456V344c0-21.382 25.803-32.09 40.922-16.971L72 360l92.686-92.686c6.248-6.248 16.379-6.248 22.627 0l25.373 25.373c6.249 6.248 6.249 16.378 0 22.627zm22.628-118.628L328 104l-32.922-31.029C279.958 57.851 290.666 32 312.048 32h112C437.303 32 448 42.745 448 56v112c0 21.382-25.803 32.09-40.922 16.971L376 152l-92.686 92.686c-6.248 6.248-16.379 6.248-22.627 0l-25.373-25.373c-6.249-6.248-6.249-16.378 0-22.627z\"\n              class=\"\"\n            ></path>\n          </svg>\n        </button>\n      </div>\n    </div>\n  </div>\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{display:inline-block;position:relative;overflow:hidden;max-width:100%;width:64em;height:36em;background-color:#000}:host(.focus-within) .bm-connected-video-player-controls--bottom,:host(.focus-within) .bm-connected-video-player-controls--top,:host(:hover) .bm-connected-video-player-controls--bottom,:host(:hover) .bm-connected-video-player-controls--top{-webkit-transform:translateY(0);transform:translateY(0)}.bm-connected-video-player{width:100%}.bm-connected-video-player__fullscreen-wrap{position:absolute;top:0;left:0;right:0;bottom:0}.bm-connected-video-player__icon{display:inline-block;font-size:inherit;height:1.5em;width:1.1em}.bm-connected-video-player-controls{color:#fff;position:absolute;left:0;right:0;padding:.5em 1em;background-color:rgba(0,0,0,.35);transition:.2s ease-in-out}.bm-connected-video-player-controls--top{top:0;-webkit-transform:translateY(-100%);transform:translateY(-100%)}.bm-connected-video-player-controls--bottom{padding-bottom:.5em;bottom:0;-webkit-transform:translateY(100%);transform:translateY(100%)}.bm-connected-video-player-controls__play-ctrl{display:inline-flex;align-items:center}.bm-connected-video-player-controls__second-level{margin-top:.25em;display:flex;justify-content:space-between;width:100%}.bm-connected-video-player-controls__btn{color:#fff;border:0;background:0 0}.bm-connected-video-player-controls__time-indicator{width:4em;color:#fff;margin:.5em}"]
                    }] }
        ];
        /** @nocollapse */
        ConnectedVideoPlayerComponent.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Inject, args: [CONNECTED_PLAYER_SRC,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONNECTED_PLAYER_CLOSE_REQUEST,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
            { type: Number, decorators: [{ type: core.Inject, args: [CONNECTED_PLAYER_VOLUME,] }] },
            { type: core.ChangeDetectorRef }
        ]; };
        ConnectedVideoPlayerComponent.propDecorators = {
            _videoElement: [{ type: core.ViewChild, args: ['videoElement', { read: core.ElementRef, static: true },] }],
            _fullscreenWrapper: [{ type: core.ViewChild, args: ['fullscreenWrapper', { read: core.ElementRef, static: true },] }],
            focusWithin: [{ type: core.HostBinding, args: ['class.focus-within',] }],
            onFocusin: [{ type: core.HostListener, args: ['focusin',] }],
            onFocusout: [{ type: core.HostListener, args: ['focusout',] }],
            onDocumentKeydown: [{ type: core.HostListener, args: ['document:keydown', ['$event'],] }]
        };
        return ConnectedVideoPlayerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var PlayerType = {
        Audio: 0,
        Video: 1,
    };
    PlayerType[PlayerType.Audio] = 'Audio';
    PlayerType[PlayerType.Video] = 'Video';
    /** @type {?} */
    var defaultOptions = {
        playerType: PlayerType.Audio,
        volume: 1,
    };
    /** @enum {string} */
    var ConnectedPlayerEventTypes = {
        OPEN: 'OPEN',
        CLOSE: 'CLOSE',
    };
    var ConnectedMediaRemoteService = /** @class */ (function () {
        function ConnectedMediaRemoteService(_injector, _overlay) {
            this._injector = _injector;
            this._overlay = _overlay;
            this._playerEventsSubject = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.getEvents = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new rxjs.Observable((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                /** @type {?} */
                var subs = _this._playerEventsSubject.subscribe(observer);
                return (/**
                 * @return {?}
                 */
                function () {
                    subs.unsubscribe();
                });
            }));
        };
        /**
         * @param {?} src
         * @param {?} host
         * @param {?=} options
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.open = /**
         * @param {?} src
         * @param {?} host
         * @param {?=} options
         * @return {?}
         */
        function (src, host, options) {
            if (options === void 0) { options = {}; }
            this.close();
            /** @type {?} */
            var actualOptions = __assign({}, defaultOptions, options);
            if (host === null && actualOptions.playerType === PlayerType.Audio) {
                throw new TypeError('Audio players should be connected to a host.');
            }
            switch (actualOptions.playerType) {
                case PlayerType.Audio:
                    this.setUpAudioPlayer(src, (/** @type {?} */ (host)), actualOptions);
                    break;
                case PlayerType.Video:
                    this.setUpVideoPlayer(src, actualOptions);
                    break;
                default:
                    throw new TypeError('Unknown PlayerType.');
            }
            this._playerEventsSubject.next({
                kind: ConnectedPlayerEventTypes.OPEN,
                source: host,
            });
        };
        /**
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.isOpen = /**
         * @return {?}
         */
        function () {
            return this._overlayRef.hasAttached();
        };
        /**
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.close = /**
         * @return {?}
         */
        function () {
            if (this._overlayRef) {
                this._overlayRef.dispose();
                this._playerEventsSubject.next({
                    kind: ConnectedPlayerEventTypes.CLOSE,
                    source: null,
                });
            }
        };
        /**
         * @private
         * @param {?} src
         * @param {?} host
         * @param {?} options
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.setUpAudioPlayer = /**
         * @private
         * @param {?} src
         * @param {?} host
         * @param {?} options
         * @return {?}
         */
        function (src, host, options) {
            /** @type {?} */
            var domEle = host && ((/** @type {?} */ (host))).nativeElement
                ? ((/** @type {?} */ (host))).nativeElement
                : ((/** @type {?} */ (host)));
            if (!domEle) {
                throw new TypeError('Invalid host element');
            }
            /** @type {?} */
            var providers = new WeakMap();
            providers.set(CONNECTED_PLAYER_SRC, src);
            providers.set(CONNECTED_PLAYER_VOLUME, options.volume);
            /** @type {?} */
            var portalInjector = new portal.PortalInjector(this._injector, providers);
            /** @type {?} */
            var componentPortal = new portal.ComponentPortal(ConnectedAudioPlayerComponent, null, portalInjector);
            /** @type {?} */
            var positionStrategy = this._overlay
                .position()
                .flexibleConnectedTo(domEle)
                .withPositions([
                {
                    originX: 'start',
                    originY: 'bottom',
                    overlayX: 'start',
                    overlayY: 'top',
                },
                {
                    originX: 'start',
                    originY: 'top',
                    overlayX: 'start',
                    overlayY: 'bottom',
                },
                {
                    originX: 'end',
                    originY: 'bottom',
                    overlayX: 'end',
                    overlayY: 'top',
                },
                {
                    originX: 'end',
                    originY: 'top',
                    overlayX: 'end',
                    overlayY: 'bottom',
                },
            ]);
            /** @type {?} */
            var scrollStrategy = this._overlay.scrollStrategies.reposition();
            this._overlayRef = this._overlay.create({
                positionStrategy: positionStrategy,
                scrollStrategy: scrollStrategy,
            });
            return this._overlayRef.attach(componentPortal);
        };
        /**
         * @private
         * @param {?} src
         * @param {?} options
         * @return {?}
         */
        ConnectedMediaRemoteService.prototype.setUpVideoPlayer = /**
         * @private
         * @param {?} src
         * @param {?} options
         * @return {?}
         */
        function (src, options) {
            var _this = this;
            /** @type {?} */
            var providers = new WeakMap();
            providers.set(CONNECTED_PLAYER_SRC, src);
            providers.set(CONNECTED_PLAYER_CLOSE_REQUEST, this.close.bind(this));
            providers.set(CONNECTED_PLAYER_VOLUME, options.volume);
            /** @type {?} */
            var portalInjector = new portal.PortalInjector(this._injector, providers);
            /** @type {?} */
            var componentPortal = new portal.ComponentPortal(ConnectedVideoPlayerComponent, null, portalInjector);
            /** @type {?} */
            var positionStrategy = this._overlay
                .position()
                .global()
                .centerHorizontally()
                .centerVertically();
            /** @type {?} */
            var scrollStrategy = this._overlay.scrollStrategies.block();
            this._overlayRef = this._overlay.create({
                positionStrategy: positionStrategy,
                scrollStrategy: scrollStrategy,
                hasBackdrop: true,
            });
            this._overlayRef.backdropClick().subscribe((/**
             * @return {?}
             */
            function () { return _this.close(); }));
            return this._overlayRef.attach(componentPortal);
        };
        ConnectedMediaRemoteService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root',
                    },] }
        ];
        /** @nocollapse */
        ConnectedMediaRemoteService.ctorParameters = function () { return [
            { type: core.Injector },
            { type: overlay.Overlay }
        ]; };
        /** @nocollapse */ ConnectedMediaRemoteService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ConnectedMediaRemoteService_Factory() { return new ConnectedMediaRemoteService(core.ɵɵinject(core.INJECTOR), core.ɵɵinject(overlay.Overlay)); }, token: ConnectedMediaRemoteService, providedIn: "root" });
        return ConnectedMediaRemoteService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ConnectedAudioPlayerComponent = /** @class */ (function () {
        function ConnectedAudioPlayerComponent(src, volume, _cdr, _elementRef, _remote) {
            this._cdr = _cdr;
            this._elementRef = _elementRef;
            this._remote = _remote;
            this.src = src;
            this.volume = volume;
        }
        Object.defineProperty(ConnectedAudioPlayerComponent.prototype, "duration", {
            get: /**
             * @return {?}
             */
            function () {
                if (this._audioElement && this._audioElement.nativeElement) {
                    return this._audioElement.nativeElement.duration;
                }
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConnectedAudioPlayerComponent.prototype, "currentTime", {
            get: /**
             * @return {?}
             */
            function () {
                if (this._audioElement && this._audioElement.nativeElement) {
                    return this._audioElement.nativeElement.currentTime;
                }
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} e
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.onDocumentClick = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this._remote.isOpen() && !this._audioElement.nativeElement.paused) {
                /** @type {?} */
                var parent_1 = (/** @type {?} */ (e.target));
                while (parent_1 &&
                    parent_1.tagName !== 'BODY' &&
                    parent_1 !== this._elementRef.nativeElement) {
                    parent_1 = (/** @type {?} */ (parent_1.parentElement));
                }
                if (parent_1 !== this._elementRef.nativeElement) {
                    this._remote.close();
                }
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.onDocumentKeydown = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this._remote.isOpen() &&
                !this._audioElement.nativeElement.paused &&
                e.key === 'Escape') {
                this._remote.close();
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.onSliderSeek = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (this._audioElement) {
                this._audioElement.nativeElement.currentTime = $event;
            }
        };
        /**
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.onTimeupdate = /**
         * @return {?}
         */
        function () {
            this._cdr.markForCheck();
        };
        /**
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.onMediaEnded = /**
         * @return {?}
         */
        function () {
            this._remote.close();
        };
        /**
         * @param {?} e
         * @return {?}
         */
        ConnectedAudioPlayerComponent.prototype.close = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            e.preventDefault();
            this._remote.close();
        };
        ConnectedAudioPlayerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-connected-audio-player',
                        template: "<audio\n  (ended)=\"onMediaEnded()\"\n  (timeupdate)=\"onTimeupdate()\"\n  [src]=\"src\"\n  [volume]=\"volume\"\n  #audioElement\n  autoplay\n></audio>\n<span class=\"bm-connected-media-player__time-indicator\">{{\n  audioElement.currentTime | bmParseDuration\n}}</span>\n<bm-media-progress-slider\n  (seek)=\"onSliderSeek($event)\"\n  [duration]=\"duration\"\n  [value]=\"currentTime\"\n  class=\"bm-connected-media-player__slider\"\n></bm-media-progress-slider>\n<span class=\"bm-connected-media-player__time-indicator\">{{\n  audioElement.duration | bmParseDuration\n}}</span>\n<button\n  (click)=\"close($event)\"\n  class=\"bm-connected-media-player__close_btn\"\n  i18n-title\n  title=\"Close\"\n  type=\"button\"\n>\n  <svg\n    aria-hidden=\"true\"\n    focusable=\"false\"\n    data-prefix=\"fas\"\n    data-icon=\"times-circle\"\n    class=\"svg-inline--fa fa-times-circle fa-w-16\"\n    class=\"bm-connected-media-player__close_icon\"\n    role=\"img\"\n    xmlns=\"http://www.w3.org/2000/svg\"\n    viewBox=\"0 0 512 512\"\n  >\n    <path\n      fill=\"currentColor\"\n      d=\"M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm121.6 313.1c4.7 4.7 4.7 12.3 0 17L338 377.6c-4.7 4.7-12.3 4.7-17 0L256 312l-65.1 65.6c-4.7 4.7-12.3 4.7-17 0L134.4 338c-4.7-4.7-4.7-12.3 0-17l65.6-65-65.6-65.1c-4.7-4.7-4.7-12.3 0-17l39.6-39.6c4.7-4.7 12.3-4.7 17 0l65 65.7 65.1-65.6c4.7-4.7 12.3-4.7 17 0l39.6 39.6c4.7 4.7 4.7 12.3 0 17L312 256l65.6 65.1z\"\n    ></path>\n  </svg>\n</button>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{align-items:center;background-color:#4a4a4a;box-shadow:0 2px 4px 0 rgba(0,0,0,.5);display:inline-flex;flex-wrap:nowrap;justify-content:center;padding:.25em 0}.bm-connected-media-player__time-indicator{color:#fff;margin:.5em 1em;width:4em}.bm-connected-media-player__close_btn{background:0 0;border:0;color:#fff;margin:.5em 1em .5em 0}.bm-connected-media-player__close_icon{width:1em}"]
                    }] }
        ];
        /** @nocollapse */
        ConnectedAudioPlayerComponent.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Inject, args: [CONNECTED_PLAYER_SRC,] }] },
            { type: Number, decorators: [{ type: core.Inject, args: [CONNECTED_PLAYER_VOLUME,] }] },
            { type: core.ChangeDetectorRef },
            { type: core.ElementRef },
            { type: ConnectedMediaRemoteService }
        ]; };
        ConnectedAudioPlayerComponent.propDecorators = {
            _audioElement: [{ type: core.ViewChild, args: ['audioElement', { read: core.ElementRef, static: true },] }],
            onDocumentClick: [{ type: core.HostListener, args: ['document:click', ['$event'],] }],
            onDocumentKeydown: [{ type: core.HostListener, args: ['document:keydown', ['$event'],] }]
        };
        return ConnectedAudioPlayerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ParseDurationPipeModule = /** @class */ (function () {
        function ParseDurationPipeModule() {
        }
        ParseDurationPipeModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ParseDurationPipe],
                        exports: [ParseDurationPipe],
                    },] }
        ];
        return ParseDurationPipeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Observable Drag. Return relative position without the first
     * container, or body, with position non static.
     * @param {?} mousedownEvent
     * @param {?=} doc
     * @param {?=} container
     * @return {?}
     */
    function dragObservable(mousedownEvent, doc, container) {
        if (doc === void 0) { doc = document; }
        if (container === void 0) { container = null; }
        if (!container) {
            container = (/** @type {?} */ (mousedownEvent.target));
            while (container.tagName !== 'BODY' &&
                getComputedStyle(container).getPropertyValue('position') !== 'static') {
                container = (/** @type {?} */ (container.parentElement));
            }
        }
        var _a = container.getBoundingClientRect(), left = _a.left, width = _a.width;
        /** @type {?} */
        var offsetX = mousedownEvent.offsetX;
        /** @type {?} */
        var mouseup = rxjs.fromEvent(doc, 'mouseup');
        /** @type {?} */
        var mousemove = rxjs.fromEvent(doc, 'mousemove');
        return mousemove.pipe(operators.map((/**
         * @param {?} mousemoveEvent
         * @return {?}
         */
        function (mousemoveEvent) {
            mousemoveEvent.preventDefault();
            return Math.min(1, Math.max(0, (mousemoveEvent.clientX - offsetX - left) / width));
        })), operators.takeUntil(mouseup));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Observable Drag. Return relative position without the first
     * container, or body, with position non static.
     * @param {?} mouseenterEvent
     * @param {?=} doc
     * @param {?=} container
     * @return {?}
     */
    function mouseoverRelativeCoordinatesObservable(mouseenterEvent, doc, container) {
        if (doc === void 0) { doc = document; }
        if (container === void 0) { container = null; }
        mouseenterEvent.preventDefault();
        if (!container) {
            container = (/** @type {?} */ (mouseenterEvent.target));
            while (container.tagName !== 'BODY' &&
                getComputedStyle(container).getPropertyValue('position') !== 'static') {
                container = (/** @type {?} */ (container.parentElement));
            }
        }
        var _a = container.getBoundingClientRect(), left = _a.left, width = _a.width;
        /** @type {?} */
        var mouseleave = rxjs.fromEvent(container, 'mouseleave');
        /** @type {?} */
        var mousemove = rxjs.fromEvent(doc, 'mousemove');
        return mousemove.pipe(operators.map((/**
         * @param {?} mousemoveEvent
         * @return {?}
         */
        function (mousemoveEvent) {
            mousemoveEvent.preventDefault();
            return Math.min(1, Math.max(0, (mousemoveEvent.clientX - left) / width));
        })), operators.takeUntil(mouseleave), operators.startWith(Math.min(1, Math.max(0, (mouseenterEvent.clientX - left) / width))));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MediaProgressSliderComponent = /** @class */ (function () {
        function MediaProgressSliderComponent(_elementRef, _document, _cdr, _dir) {
            this._elementRef = _elementRef;
            this._document = _document;
            this._cdr = _cdr;
            this._dir = _dir;
            this.valuemin = 0;
            this.tabindex = 0;
            this.role = 'slider';
            this.seek = new core.EventEmitter();
            this._isDragging = false;
            this._isOver = false;
        }
        Object.defineProperty(MediaProgressSliderComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._value = v;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} $event
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.onMouseenter = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            this._isOver = true;
            mouseoverRelativeCoordinatesObservable($event, this._document, this._elementRef.nativeElement).subscribe({
                next: (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    _this.pointerTime = val * (_this.duration || 0);
                    /** @type {?} */
                    var overTime = Math.max(0, _this.getRelativeLeft(_this.pointerTime) -
                        _this.getRelativeLeft(_this.value));
                    if (overTime > 0 &&
                        _this._previewBar &&
                        _this._previewBar.nativeElement) {
                        /** @type {?} */
                        var relativeLeft = _this.getRelativeLeft(_this.value);
                        _this._previewBar.nativeElement.style.left = relativeLeft + "px";
                        _this._previewBar.nativeElement.style.width = overTime + "px";
                    }
                    _this._cdr.markForCheck();
                }),
                error: (/**
                 * @return {?}
                 */
                function () {
                    _this._isOver = false;
                }),
                complete: (/**
                 * @return {?}
                 */
                function () {
                    _this._isOver = false;
                    _this._cdr.markForCheck();
                }),
            });
        };
        /**
         * @param {?} e
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.onClick = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (!this._isDragging) {
                e.preventDefault();
                var offsetX = e.offsetX;
                var width = this._elementRef.nativeElement.getBoundingClientRect().width;
                /** @type {?} */
                var percent = offsetX / width;
                this.seek.emit(percent * (this.duration || 0));
            }
        };
        // tslint:disable-next-line:cyclomatic-complexity
        // tslint:disable-next-line:cyclomatic-complexity
        /**
         * @param {?} e
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.onKeydown = 
        // tslint:disable-next-line:cyclomatic-complexity
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var emitChanges = false;
            if (this.duration) {
                /** @type {?} */
                var bigStep = 0.1 * this.duration;
                switch (e.keyCode) {
                    case keycodes.DOWN_ARROW: {
                        e.preventDefault();
                        this._value = Math.max(0, this._value - 1);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.UP_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(this.duration, this._value + 1);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.LEFT_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(Math.max(0, this._value + (this._dir.value === 'ltr' ? -1 : 1)), this.duration);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.RIGHT_ARROW: {
                        e.preventDefault();
                        this._value = Math.min(Math.max(0, this._value + (this._dir.value === 'ltr' ? 1 : -1)), this.duration);
                        emitChanges = true;
                        break;
                    }
                    case keycodes.PAGE_UP:
                        e.preventDefault();
                        this._value = Math.max(0, this._value + bigStep);
                        emitChanges = true;
                        break;
                    case keycodes.PAGE_DOWN:
                        e.preventDefault();
                        this._value = Math.max(0, this._value - bigStep);
                        emitChanges = true;
                        break;
                    default:
                }
            }
            if (emitChanges) {
                this.seek.emit(this.value);
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.getRelativeLeft = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this._elementRef.nativeElement && value && this.duration) {
                var width = this._elementRef.nativeElement.getBoundingClientRect().width;
                /** @type {?} */
                var relative = value / (this.duration - this.valuemin);
                return relative * width;
            }
            return 0;
        };
        /**
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.showThumb = /**
         * @return {?}
         */
        function () {
            return this._isDragging || this._isOver;
        };
        /**
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.showPreviewBar = /**
         * @return {?}
         */
        function () {
            return this._isOver && !this._isDragging;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        MediaProgressSliderComponent.prototype.onThumbMousedown = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            this._cdr.detach();
            this._isDragging = true;
            /** @type {?} */
            var dragObservable$ = dragObservable($event, this._document, this._elementRef.nativeElement);
            // The two observables with different throttles target components
            // that should update at different rates. The bounced targets the
            // the time tooltip, while the non bounced targets the dragged thumb
            // and bars.
            dragObservable$
                .pipe(operators.debounceTime(15))
                .subscribe((/**
             * @return {?}
             */
            function () { return _this._cdr.detectChanges(); }));
            dragObservable$.subscribe({
                next: (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    _this._value = val * (_this.duration || 0);
                    /** @type {?} */
                    var relativeLeft = _this.getRelativeLeft(_this.value);
                    ((/** @type {?} */ ($event.target))).style.left = relativeLeft + "px";
                    if (_this._doneBar && _this._doneBar.nativeElement) {
                        _this._doneBar.nativeElement.style.width = relativeLeft + "px";
                    }
                    _this.seek.emit(_this.value);
                }),
                error: (/**
                 * @return {?}
                 */
                function () {
                    _this._cdr.reattach();
                }),
                complete: (/**
                 * @return {?}
                 */
                function () {
                    _this._cdr.reattach();
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this._isDragging = false;
                    }), 10);
                }),
            });
        };
        MediaProgressSliderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'bm-media-progress-slider',
                        template: "<span\n  *ngIf=\"showPreviewBar()\"\n  #previewBar\n  class=\"bm-media-progress-slider__bar bm-media-progress-slider__bar--preview\"\n></span>\n<span\n  #doneBar\n  class=\"bm-media-progress-slider__bar bm-media-progress-slider__bar--done\"\n  [ngStyle]=\"{ 'width.px': getRelativeLeft(value) }\"\n></span>\n<span\n  *ngIf=\"showThumb()\"\n  #thumb\n  class=\"bm-media-progress-slider-thumb\"\n  [ngStyle]=\"{ 'left.px': getRelativeLeft(value), 'margin-left.em': -0.5 }\"\n  (mousedown)=\"onThumbMousedown($event)\"\n></span>\n<span\n  *bmMediaProgressTooltip=\"_elementRef\"\n  class=\"bm-media-progress-slider-tooltip\"\n  >{{ pointerTime | bmParseDuration }}</span\n>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{height:.5em;border-radius:.4em;display:inline-block;background-color:var(--secondary-color,#bcbcbc);max-width:100%;min-width:200px;position:relative}:host:focus{outline:solid var(--anchor-color,#4399fd) 2px}.bm-media-progress-slider__bar{height:.5em;border-radius:.4em;display:inline-block;position:absolute}.bm-media-progress-slider__bar--done{background-color:var(--header-background-color,#3e71ad)}.bm-media-progress-slider__bar--preview{background-color:var(--secondary-color-hover,#959494)}.bm-media-progress-slider-thumb{position:absolute;background-color:var(--header-background-color,#3e71ad);border-radius:50%;display:inline-block;height:1em;width:1em;top:-.25em}.bm-media-progress-slider-tooltip{display:inline-block;background-color:rgba(0,0,0,.7);border:1px solid #000;border-radius:3px;padding:.25em .5em;color:#fff;font-size:smaller}"]
                    }] }
        ];
        /** @nocollapse */
        MediaProgressSliderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
            { type: core.ChangeDetectorRef },
            { type: bidi.Directionality }
        ]; };
        MediaProgressSliderComponent.propDecorators = {
            duration: [{ type: core.HostBinding, args: ['attr.aria-valuemax',] }, { type: core.Input }],
            value: [{ type: core.HostBinding, args: ['attr.aria-valuenow',] }, { type: core.Input }],
            valuemin: [{ type: core.HostBinding, args: ['attr.aria-valuemin',] }, { type: core.Input }],
            tabindex: [{ type: core.HostBinding, args: ['attr.tabindex',] }, { type: core.Input }],
            role: [{ type: core.HostBinding, args: ['attr.role',] }],
            seek: [{ type: core.Output }],
            _doneBar: [{ type: core.ViewChild, args: ['doneBar', { read: core.ElementRef, static: true },] }],
            _previewBar: [{ type: core.ViewChild, args: ['previewBar', { read: core.ElementRef, static: false },] }],
            onMouseenter: [{ type: core.HostListener, args: ['mouseenter', ['$event'],] }],
            onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }],
            onKeydown: [{ type: core.HostListener, args: ['keydown', ['$event'],] }]
        };
        return MediaProgressSliderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MediaProgressTooltipDirective = /** @class */ (function () {
        function MediaProgressTooltipDirective(_templateRef, _viewContainerRef, _overlay, _document, _render) {
            this._templateRef = _templateRef;
            this._viewContainerRef = _viewContainerRef;
            this._overlay = _overlay;
            this._document = _document;
            this._render = _render;
            this._templatePortal = new portal.TemplatePortal(this._templateRef, this._viewContainerRef);
        }
        Object.defineProperty(MediaProgressTooltipDirective.prototype, "bmMediaProgressTooltip", {
            get: /**
             * @return {?}
             */
            function () {
                return this._bmMediaProgressTooltip;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                if (this._teardownListener) {
                    this._teardownListener();
                }
                if (v) {
                    this._bmMediaProgressTooltip = v;
                    this._hostDOMEle = ((/** @type {?} */ (v))).nativeElement
                        ? ((/** @type {?} */ (v))).nativeElement
                        : ((/** @type {?} */ (v)));
                    this._teardownListener = this._render.listen(this._hostDOMEle, 'mouseenter', this.onMouseenter.bind(this));
                }
                else {
                    this._hostDOMEle = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MediaProgressTooltipDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.tearDownPortals();
            if (this._teardownListener) {
                this._teardownListener();
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        MediaProgressTooltipDirective.prototype.onMouseenter = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            if (!this._hostDOMEle || this._templatePortal.isAttached) {
                return;
            }
            this.tearDownPortals();
            var width = this._hostDOMEle.getBoundingClientRect().width;
            this._positionStategy = this._overlay
                .position()
                .flexibleConnectedTo(this._hostDOMEle)
                .withPositions([
                {
                    originX: 'start',
                    originY: 'top',
                    overlayX: 'start',
                    overlayY: 'bottom',
                },
            ])
                .withDefaultOffsetY(-5);
            this._overlayRef = this._overlay.create({
                positionStrategy: this._positionStategy,
            });
            var rootNodes = this._overlayRef.attach(this._templatePortal).rootNodes;
            /** @type {?} */
            var getOffset = (/**
             * @return {?}
             */
            function () {
                if (rootNodes && rootNodes.length) {
                    return ((/** @type {?} */ (rootNodes[0]))).getBoundingClientRect().width / 2;
                }
                return 0;
            });
            mouseoverRelativeCoordinatesObservable($event, this._document).subscribe({
                next: (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    if (_this._positionStategy) {
                        _this._positionStategy
                            .withDefaultOffsetX(val * width - getOffset())
                            .reapplyLastPosition();
                    }
                }),
                complete: (/**
                 * @return {?}
                 */
                function () {
                    _this.tearDownPortals();
                }),
            });
        };
        /**
         * @private
         * @return {?}
         */
        MediaProgressTooltipDirective.prototype.tearDownPortals = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._templatePortal && this._templatePortal.isAttached) {
                this._templatePortal.detach();
            }
            if (this._overlayRef) {
                this._overlayRef.detach();
                this._overlayRef.dispose();
            }
            if (this._positionStategy) {
                this._positionStategy.dispose();
            }
        };
        MediaProgressTooltipDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bmMediaProgressTooltip]',
                    },] }
        ];
        /** @nocollapse */
        MediaProgressTooltipDirective.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ViewContainerRef },
            { type: overlay.Overlay },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
            { type: core.Renderer2 }
        ]; };
        MediaProgressTooltipDirective.propDecorators = {
            bmMediaProgressTooltip: [{ type: core.Input }],
            value: [{ type: core.Input }]
        };
        return MediaProgressTooltipDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MediaProgressSliderComponentModule = /** @class */ (function () {
        function MediaProgressSliderComponentModule() {
        }
        MediaProgressSliderComponentModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [bidi.BidiModule, common.CommonModule, ParseDurationPipeModule],
                        declarations: [MediaProgressSliderComponent, MediaProgressTooltipDirective],
                        exports: [MediaProgressSliderComponent, MediaProgressTooltipDirective],
                    },] }
        ];
        return MediaProgressSliderComponentModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ProgressBarComponentModule = /** @class */ (function () {
        function ProgressBarComponentModule() {
        }
        ProgressBarComponentModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ProgressBarComponent],
                        exports: [ProgressBarComponent],
                    },] }
        ];
        return ProgressBarComponentModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BMATMediaPlayersModule = /** @class */ (function () {
        function BMATMediaPlayersModule() {
        }
        // tslint:disable-next-line:function-name
        // tslint:disable-next-line:function-name
        /**
         * @return {?}
         */
        BMATMediaPlayersModule.forRoot = 
        // tslint:disable-next-line:function-name
        /**
         * @return {?}
         */
        function () {
            return {
                ngModule: BMATMediaPlayersModule,
                providers: [ConnectedMediaRemoteService],
            };
        };
        BMATMediaPlayersModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            overlay.OverlayModule,
                            ParseDurationPipeModule,
                            ProgressBarComponentModule,
                            MediaProgressSliderComponentModule,
                        ],
                        declarations: [
                            BMATAudioPlayerComponent,
                            BMMediaOutputComponent,
                            ConnectedAudioPlayerComponent,
                            ConnectedVideoPlayerComponent,
                        ],
                        exports: [
                            BMATAudioPlayerComponent,
                            BMMediaOutputComponent,
                            ConnectedAudioPlayerComponent,
                            ConnectedVideoPlayerComponent,
                            ParseDurationPipeModule,
                            ProgressBarComponentModule,
                            MediaProgressSliderComponentModule,
                        ],
                        entryComponents: [
                            ConnectedAudioPlayerComponent,
                            ConnectedVideoPlayerComponent,
                        ],
                    },] }
        ];
        return BMATMediaPlayersModule;
    }());

    exports.BMATAudioPlayerComponent = BMATAudioPlayerComponent;
    exports.BMATMediaPlayersModule = BMATMediaPlayersModule;
    exports.BMMediaOutputComponent = BMMediaOutputComponent;
    exports.ConnectedMediaRemoteService = ConnectedMediaRemoteService;
    exports.ConnectedPlayerEventTypes = ConnectedPlayerEventTypes;
    exports.ParseDurationPipe = ParseDurationPipe;
    exports.ParseDurationPipeModule = ParseDurationPipeModule;
    exports.PlayerType = PlayerType;
    exports.ProgressBarComponent = ProgressBarComponent;
    exports.ProgressBarComponentModule = ProgressBarComponentModule;
    exports.ɵa = MediaProgressSliderComponentModule;
    exports.ɵb = MediaProgressSliderComponent;
    exports.ɵc = MediaProgressTooltipDirective;
    exports.ɵd = ConnectedAudioPlayerComponent;
    exports.ɵe = CONNECTED_PLAYER_SRC;
    exports.ɵf = CONNECTED_PLAYER_VOLUME;
    exports.ɵg = ConnectedVideoPlayerComponent;
    exports.ɵh = CONNECTED_PLAYER_CLOSE_REQUEST;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bmat-angular-media-players.umd.js.map
