import { CommonModule } from '@angular/common';
import { Component, ChangeDetectionStrategy, ViewEncapsulation, forwardRef, Renderer2, ViewChildren, ElementRef, Input, ChangeDetectorRef, ViewChild, HostBinding, Output, EventEmitter, ContentChildren, Directive, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { trigger, state, style, transition, animate } from '@angular/animations';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BMDurationInputComponent = /** @class */ (function () {
    function BMDurationInputComponent(renderer) {
        this.renderer = renderer;
        // tslint:disable-next-line:prefer-array-literal
        this.timeValues = new Array(3).fill(null);
        // tslint:disable:no-any
        // tslint:disable:no-empty
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
    }
    Object.defineProperty(BMDurationInputComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this.computeTotalTime();
        },
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.writeValue(val);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} index
     * @param {?} $event
     * @return {?}
     */
    BMDurationInputComponent.prototype.format = /**
     * @param {?} index
     * @param {?} $event
     * @return {?}
     */
    function (index, $event) {
        /** @type {?} */
        var inputEle = (/** @type {?} */ ($event.target));
        /** @type {?} */
        var value = Number.parseInt(inputEle.value, 10);
        if (Number.isNaN(value)) {
            value = 0;
        }
        if (index && value >= 60) {
            value = (value % 100) % 60;
        }
        this.timeValues[index] = value;
        this.propagateChange(this.computeTotalTime());
        /** @type {?} */
        var formatedVal = this.timeValues[index] < 10
            ? '0' + this.timeValues[index]
            : this.timeValues[index];
        this.renderer.setProperty(inputEle, 'value', formatedVal);
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    BMDurationInputComponent.prototype.writeValue = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        if (!value && value !== 0) {
            // tslint:disable-next-line:prefer-array-literal
            this.timeValues = new Array(3).fill(null);
        }
        else {
            /** @type {?} */
            var coerceInteger = Number.parseInt(value, 10);
            if (Number.isNaN(coerceInteger)) {
                coerceInteger = 0;
            }
            coerceInteger = Math.max(0, coerceInteger);
            [
                Math.floor(coerceInteger / 3600),
                Math.floor(coerceInteger / 60) % 60,
                coerceInteger % 60,
            ].forEach((/**
             * @param {?} val
             * @param {?} i
             * @return {?}
             */
            function (val, i) {
                _this.timeValues[i] = val;
            }));
        }
        this.updateInputValues();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMDurationInputComponent.prototype.registerOnChange = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    // tslint:disable-next-line:no-empty
    // tslint:disable-next-line:no-empty
    /**
     * @return {?}
     */
    BMDurationInputComponent.prototype.registerOnTouched = 
    // tslint:disable-next-line:no-empty
    /**
     * @return {?}
     */
    function () { };
    /**
     * @return {?}
     */
    BMDurationInputComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.updateInputValues();
    };
    /**
     * @private
     * @return {?}
     */
    BMDurationInputComponent.prototype.computeTotalTime = /**
     * @private
     * @return {?}
     */
    function () {
        return this.timeValues.reduce((/**
         * @param {?} acum
         * @param {?} curr
         * @param {?} i
         * @return {?}
         */
        function (acum, curr, i) {
            if (curr) {
                acum += ((/** @type {?} */ (curr))) * Math.pow(60, (2 - i));
            }
            return acum;
        }), 0);
    };
    /**
     * @private
     * @return {?}
     */
    BMDurationInputComponent.prototype.updateInputValues = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.viewTimeValues) {
            this.viewTimeValues.forEach((/**
             * @param {?} element
             * @param {?} index
             * @return {?}
             */
            function (element, index) {
                /** @type {?} */
                var value = _this.timeValues[index];
                /** @type {?} */
                var formatedValue = value < 10 ? '0' + value : value;
                _this.renderer.setProperty(element.nativeElement, 'value', formatedValue);
            }));
        }
    };
    BMDurationInputComponent.decorators = [
        { type: Component, args: [{
                    selector: 'bm-input-duration',
                    template: "<input #hours type=\"number\" min=\"0\" class=\"bm-input bm-duration-input__input\"\n  (input)=\"format(0, $event)\" (keyup)=\"format(0, $event)\" placeholder=\"HH\" />\n<input #minutes type=\"number\" min=\"0\" max=\"59\"  class=\"bm-input bm-duration-input__input\"\n  (input)=\"format(1, $event)\" (keyup)=\"format(1, $event)\" placeholder=\"MM\"/>\n<input #seconds type=\"number\" min=\"0\" max=\"59\"  class=\"bm-input bm-duration-input__input\"\n  (input)=\"format(2, $event)\" (keyup)=\"format(2, $event)\" placeholder=\"SS\"/>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            // tslint:disable-next-line:no-forward-ref
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BMDurationInputComponent; })),
                            multi: true,
                        },
                    ],
                    styles: ["bm-input-duration{display:inline-flex;flex-wrap:nowrap}.bm-duration-input--inverse .bm-duration-input__input{background-color:#fff}.bm-duration-input__input{width:3em}"]
                }] }
    ];
    /** @nocollapse */
    BMDurationInputComponent.ctorParameters = function () { return [
        { type: Renderer2 }
    ]; };
    BMDurationInputComponent.propDecorators = {
        viewTimeValues: [{ type: ViewChildren, args: ['hours, minutes, seconds', { read: ElementRef },] }],
        value: [{ type: Input }]
    };
    return BMDurationInputComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BMMultiselectComponent = /** @class */ (function () {
    function BMMultiselectComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        /**
         * Input values to directly copy to inner input
         */
        this.name = '';
        this.tabIndex = 0;
        this.options = [];
        this.availableOptions = [];
        this.filteredOptions = [];
        this.selectedOptionsList = [];
        this.selectedOptions = new Set();
        this.showSuggestions = false;
        // tslint:disable-next-line:no-any no-empty
        this.onTouched = (/**
         * @return {?}
         */
        function () { });
        // tslint:disable:no-any
        // tslint:disable:no-empty
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
    }
    Object.defineProperty(BMMultiselectComponent.prototype, "isFocused", {
        get: /**
         * @return {?}
         */
        function () {
            return this.focused;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BMMultiselectComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return Array.from(this.selectedOptions.values());
        },
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            if (Array.isArray(v)) {
                this.selectedOptions = new Set(v);
            }
            this.updateListAndSuggestions();
            this.updateSelectedList();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} option
     * @param {?} event
     * @return {?}
     */
    BMMultiselectComponent.prototype.selectOption = /**
     * @param {?} option
     * @param {?} event
     * @return {?}
     */
    function (option, event) {
        /** @type {?} */
        var target = (/** @type {?} */ (event.target));
        if (target.nextElementSibling) {
            ((/** @type {?} */ (target.nextElementSibling))).focus();
        }
        else if (target.previousElementSibling) {
            ((/** @type {?} */ (target.previousElementSibling))).focus();
        }
        this.selectedOptions.add(option.key);
        this.valueChange();
    };
    /**
     * @param {?} option
     * @return {?}
     */
    BMMultiselectComponent.prototype.removeOption = /**
     * @param {?} option
     * @return {?}
     */
    function (option) {
        this.selectedOptions.delete(option.key);
        this.valueChange();
    };
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.removeAll = /**
     * @return {?}
     */
    function () {
        this.selectedOptions.clear();
        this.valueChange();
    };
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.addAll = /**
     * @return {?}
     */
    function () {
        this.selectedOptions = new Set(this.options.map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.key; })));
        this.valueChange();
        this.showSuggestions = false;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BMMultiselectComponent.prototype.inputKeyUp = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        switch (event.keyCode) {
            case 40: // Down arrow
                this.showSuggestions = true;
                if (this.suggestionList.first &&
                    this.suggestionList.first.nativeElement) {
                    this.suggestionList.first.nativeElement.focus();
                }
                break;
            case 27: // Escape
                this.showSuggestions = false;
                break;
            default:
                this.updateSuggestionList();
        }
    };
    /**
     * @param {?} event
     * @param {?} index
     * @param {?} value
     * @return {?}
     */
    BMMultiselectComponent.prototype.suggestionKeyUp = /**
     * @param {?} event
     * @param {?} index
     * @param {?} value
     * @return {?}
     */
    function (event, index, value) {
        var _this = this;
        /** @type {?} */
        var suggestionLi = this.suggestionList.toArray();
        /** @type {?} */
        var keyDown = (/**
         * @return {?}
         */
        function () {
            if (index === 0 &&
                _this.suggestionList.last &&
                _this.suggestionList.last.nativeElement) {
                _this.suggestionList.last.nativeElement.focus();
            }
            else if (suggestionLi[index - 1] &&
                suggestionLi[index - 1].nativeElement) {
                suggestionLi[index - 1].nativeElement.focus();
            }
        });
        switch (event.keyCode) {
            case 40: // Up arrow
                if (index === this.filteredOptions.length - 1 &&
                    this.suggestionList.first &&
                    this.suggestionList.first.nativeElement) {
                    this.suggestionList.first.nativeElement.focus();
                }
                else if (suggestionLi[index + 1] &&
                    suggestionLi[index + 1].nativeElement) {
                    suggestionLi[index + 1].nativeElement.focus();
                }
                event.preventDefault();
                break;
            case 38: // Down arrow
                keyDown();
                event.preventDefault();
                break;
            case 27: // Escape
                this.showSuggestions = false;
                break;
            case 13: // Enter
                this.selectOption(value, event);
                keyDown();
                break;
            default:
                return;
        }
    };
    /**
     * @param {?} event
     * @param {?} value
     * @return {?}
     */
    BMMultiselectComponent.prototype.selectedItemKeyup = /**
     * @param {?} event
     * @param {?} value
     * @return {?}
     */
    function (event, value) {
        if (event.keyCode === 46 || event.keyCode === 8) {
            event.preventDefault();
            this.removeOption(value);
        }
    };
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.afterOptionFocus = /**
     * @return {?}
     */
    function () {
        this.showSuggestions = false;
    };
    // Focus Blur Handle
    // Focus Blur Handle
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.inputFocus = 
    // Focus Blur Handle
    /**
     * @return {?}
     */
    function () {
        this.focused = true;
        this.showSuggestions = true;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BMMultiselectComponent.prototype.inputFocusout = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var relatedTarget = (/** @type {?} */ (event.relatedTarget));
        /** @type {?} */
        var suggestions = this.suggestionList.map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.nativeElement; }));
        if (suggestions.indexOf(relatedTarget) === -1) {
            this.showSuggestions = false;
        }
        this.focused = false;
        this.onTouched();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BMMultiselectComponent.prototype.suggestionFocusout = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var target = (/** @type {?} */ (event.target));
        /** @type {?} */
        var relatedTarget = (/** @type {?} */ (event.relatedTarget));
        if (!relatedTarget ||
            target.parentElement !== relatedTarget.parentElement) {
            this.showSuggestions = false;
        }
    };
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.updateListAndSuggestions();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    BMMultiselectComponent.prototype.writeValue = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.value = value;
        this.changeDetectorRef.markForCheck();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMMultiselectComponent.prototype.registerOnChange = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMMultiselectComponent.prototype.registerOnTouched = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @return {?}
     */
    BMMultiselectComponent.prototype.focus = /**
     * @return {?}
     */
    function () {
        if (this.input && this.input.nativeElement) {
            this.input.nativeElement.focus();
        }
    };
    /**
     * @private
     * @return {?}
     */
    BMMultiselectComponent.prototype.updateSelectedList = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.selectedOptionsList = this.options.filter((/**
         * @param {?} option
         * @return {?}
         */
        function (option) {
            return _this.selectedOptions.has(option.key);
        }));
    };
    /**
     * @private
     * @return {?}
     */
    BMMultiselectComponent.prototype.updateListAndSuggestions = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.availableOptions = this.options.filter((/**
         * @param {?} option
         * @return {?}
         */
        function (option) { return !_this.selectedOptions.has(option.key); }));
        this.updateSuggestionList();
    };
    /**
     * @private
     * @return {?}
     */
    BMMultiselectComponent.prototype.updateSuggestionList = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var value = ((/** @type {?} */ ((this.input.nativeElement)))).value.toLowerCase();
        this.filteredOptions = this.availableOptions.filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.displayValue.toLowerCase().search(value) !== -1; }));
    };
    /**
     * @private
     * @return {?}
     */
    BMMultiselectComponent.prototype.valueChange = /**
     * @private
     * @return {?}
     */
    function () {
        this.propagateChange(Array.from(this.selectedOptions.values()));
        this.updateListAndSuggestions();
        this.updateSelectedList();
        if (this.availableOptions.length === 0 &&
            this.input &&
            this.input.nativeElement) {
            this.input.nativeElement.focus();
        }
    };
    BMMultiselectComponent.decorators = [
        { type: Component, args: [{
                    selector: 'bm-multiselect',
                    template: "<div class=\"bm-multiselect-input-container\">\n  <input\n    class=\"bm-multiselect-input bm-input\"\n    #input\n    autocomplete=\"off\"\n    [required]=\"required\"\n    [disabled]=\"disabled\"\n    [name]=\"name\"\n    [tabIndex]=\"tabIndex\"\n    [readonly]=\"readonly\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledby\"\n    (keyup)=\"inputKeyUp($event)\"\n    (focus)=\"inputFocus()\"\n    (focusout)=\"inputFocusout($event)\"\n  />\n  <div\n    *ngIf=\"showSuggestions\"\n    tabindex=\"-1\"\n    class=\"bm-multiselect-suggestions-container\"\n    [@fadeInOut]=\"'in'\"\n  >\n    <ul>\n      <li i18n tabindex=\"-1\" *ngIf=\"filteredOptions.length === 0\">\n        No matches found\n      </li>\n      <li\n        #sugg\n        tabindex=\"0\"\n        *ngFor=\"let option of filteredOptions; let i = index\"\n        aria-selected=\"true\"\n        (click)=\"selectOption(option, $event)\"\n        (focusout)=\"suggestionFocusout($event)\"\n        (keydown)=\"suggestionKeyUp($event, i, option)\"\n      >\n        {{ option.displayValue }}\n      </li>\n    </ul>\n  </div>\n  <button\n    class=\"bm-multiselect-add-all\"\n    i18n\n    (click)=\"addAll()\"\n    (focus)=\"afterOptionFocus()\"\n  >\n    Add all\n  </button>\n</div>\n<div *ngIf=\"value.length\" class=\"bm-multiselect-selected-options\">\n  <div class=\"bm-multiselect-button-container\">\n    <button class=\"bm-multiselect-remove-all\" i18n (click)=\"removeAll()\">\n      Remove all\n    </button>\n  </div>\n  <ul>\n    <li\n      *ngFor=\"let option of selectedOptionsList\"\n      tabindex=\"0\"\n      aria-selected=\"false\"\n      (keyup)=\"selectedItemKeyup($event, option)\"\n    >\n      <span>{{ option.displayValue }}</span>\n      <button\n        bmIconButton\n        class=\"bm-multiselect-remove-item fas fa-trash\"\n        arial-label=\"Remove this item\"\n        (click)=\"removeOption(option)\"\n        i18n-arial-label\n      ></button>\n    </li>\n  </ul>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            // tslint:disable-next-line:no-forward-ref
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BMMultiselectComponent; })),
                            multi: true,
                        },
                    ],
                    animations: [
                        trigger('fadeInOut', [
                            state('in', style({ opacity: 1 })),
                            transition('void => *', [
                                style({
                                    opacity: 0,
                                }),
                                animate('0.2s ease-in'),
                            ]),
                            transition('* => void', [
                                animate('0.2s ease-out', style({
                                    opacity: 0,
                                })),
                            ]),
                        ]),
                    ],
                    styles: ["bm-multiselect{display:inline-block}.bm-multiselect-input-container{display:block;position:relative}.bm-multiselect-input{width:100%;box-sizing:border-box}.bm-multiselect-add-all,.bm-multiselect-remove-all,.bm-multiselect-remove-item{background:0 0;color:#4399fd;border:none}.bm-multiselect-add-all{position:absolute;right:0;top:.5em}.bm-multiselect-suggestions-container{position:absolute;top:1.8em;width:100%;background:#fff;max-height:10em;box-shadow:0 0 4px 0 rgba(0,0,0,.09);overflow-x:auto;z-index:1000}.bm-multiselect-suggestions-container ul{list-style:none;padding:0;margin:0}.bm-multiselect-suggestions-container li{padding:.2em 1em;cursor:pointer}.bm-multiselect-suggestions-container li:nth-child(odd){background-color:#fff}.bm-multiselect-suggestions-container li:nth-child(even){background-color:var(--secondary-color,#bcbcbc)}.bm-multiselect-suggestions-container li:focus,.bm-multiselect-suggestions-container li:hover{background-color:var(--secondary-color-hover,#959494)}.bm-multiselect-selected-options{text-align:left}.bm-multiselect-selected-options .bm-multiselect-button-container{text-align:right;padding:1em 0}.bm-multiselect-selected-options .bm-multiselect-remove-item{display:none}.bm-multiselect-selected-options ul{margin:0;padding:0;max-height:15em;overflow-x:auto;list-style-type:none}.bm-multiselect-selected-options li{padding:.5em;display:flex}.bm-multiselect-selected-options li:nth-child(odd){background-color:#f5f7f8}.bm-multiselect-selected-options li:focus{background-color:var(--secondary-color-hover,#959494)}.bm-multiselect-selected-options li:hover .bm-multiselect-remove-item{display:block;margin-right:0;margin-left:auto}"]
                }] }
    ];
    /** @nocollapse */
    BMMultiselectComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    BMMultiselectComponent.propDecorators = {
        input: [{ type: ViewChild, args: ['input', { static: true },] }],
        suggestionList: [{ type: ViewChildren, args: ['sugg',] }],
        isFocused: [{ type: HostBinding, args: ['class.bm-multiselect-focused',] }],
        name: [{ type: Input }],
        tabIndex: [{ type: Input }],
        required: [{ type: Input }],
        disabled: [{ type: Input }],
        readonly: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        value: [{ type: Input }],
        options: [{ type: Input }]
    };
    return BMMultiselectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BMInputSearchComponent = /** @class */ (function () {
    function BMInputSearchComponent(_renderer) {
        this._renderer = _renderer;
        /**
         * Input values to directly copy to inner checkbox
         */
        this.name = '';
        this.placeholder = '';
        this.tabIndex = 0;
        // tslint:disable-next-line:no-reserved-keywords
        this.type = 'text';
        /**
         * Suggestions specifics
         */
        this.showSuggestions = false;
        this.minSuggestionChars = 2;
        this.search = new EventEmitter();
        // tslint:disable-next-line:no-any no-empty
        this.onTouched = (/**
         * @return {?}
         */
        function () { });
        // tslint:disable:no-any
        // tslint:disable:no-empty
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
    }
    Object.defineProperty(BMInputSearchComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this.input.nativeElement.value;
        },
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            if (v) {
                this._renderer.setProperty(this.input.nativeElement, 'value', v);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} event
     * @return {?}
     */
    BMInputSearchComponent.prototype.inputKeyUp = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        switch (event.keyCode) {
            case 40: // Down arrow
                if (this.suggestionList.first) {
                    this.suggestionList.first.nativeElement.focus();
                }
                break;
            case 27: // Escape
                this.closeSuggestions();
                break;
            default:
                /** @type {?} */
                var value_1 = ((/** @type {?} */ (event.target))).value.toLowerCase();
                if (value_1.length >= this.minSuggestionChars &&
                    Array.isArray(this.suggestions)) {
                    this.showSuggestions = true;
                    this.filteredSuggestions = this.suggestions
                        .map((/**
                     * @param {?} item
                     * @return {?}
                     */
                    function (item) { return item.toString().toLowerCase(); }))
                        .filter((/**
                     * @param {?} item
                     * @return {?}
                     */
                    function (item) { return item.search(value_1) !== -1; }));
                }
                else {
                    this.showSuggestions = false;
                }
                return;
        }
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} event
     * @param {?} index
     * @param {?} value
     * @return {?}
     */
    BMInputSearchComponent.prototype.suggestionKeyUp = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} event
     * @param {?} index
     * @param {?} value
     * @return {?}
     */
    function (event, index, value) {
        /** @type {?} */
        var suggestionLi = this.suggestionList.toArray();
        switch (event.keyCode) {
            case 40: // Up arrow
                if (index === this.suggestions.length - 1) {
                    this.suggestionList.first.nativeElement.focus();
                }
                else {
                    suggestionLi[index + 1].nativeElement.focus();
                }
                event.preventDefault();
                break;
            case 38: // Down arrow
                if (index === 0) {
                    this.suggestionList.last.nativeElement.focus();
                }
                else {
                    suggestionLi[index - 1].nativeElement.focus();
                }
                event.preventDefault();
                break;
            case 27: // Escape
                this.closeSuggestions();
                break;
            case 13: // Enter
                this.setInput(value);
                break;
            default:
                return;
        }
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} v
     * @return {?}
     */
    BMInputSearchComponent.prototype.setInput = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} v
     * @return {?}
     */
    function (v) {
        this.value = v;
        this.propagateChange(this.value);
        this.closeSuggestions();
    };
    /**
     * Custom Input functions
     */
    /**
     * Custom Input functions
     * @return {?}
     */
    BMInputSearchComponent.prototype.inputBlur = /**
     * Custom Input functions
     * @return {?}
     */
    function () {
        this.onTouched();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    BMInputSearchComponent.prototype.writeValue = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._renderer.setProperty(this.input.nativeElement, 'value', value);
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMInputSearchComponent.prototype.registerOnChange = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMInputSearchComponent.prototype.registerOnTouched = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BMInputSearchComponent.prototype.inputChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        var value = (/** @type {?} */ (event.target)).value;
        this.propagateChange(value);
    };
    /**
     * @return {?}
     */
    BMInputSearchComponent.prototype.focus = /**
     * @return {?}
     */
    function () {
        this.input.nativeElement.focus();
    };
    /**
     * @private
     * @return {?}
     */
    BMInputSearchComponent.prototype.closeSuggestions = /**
     * @private
     * @return {?}
     */
    function () {
        this.input.nativeElement.focus();
        this.showSuggestions = false;
    };
    BMInputSearchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'bm-input-search',
                    template: "<div class=\"bm-input bm-input-search__input-container\">\n  <input\n    #input\n    class=\"bm-input bm-input-search__input\"\n    autocomplete=\"off\"\n    [type]=\"type\"\n    [required]=\"required\"\n    [disabled]=\"disabled\"\n    [name]=\"name\"\n    [tabIndex]=\"tabIndex\"\n    [readonly]=\"readonly\"\n    [placeholder]=\"placeholder\"\n    [attr.aria-label]=\"ariaLabel\"\n    [attr.aria-labelledby]=\"ariaLabelledby\"\n    (keyup)=\"inputKeyUp($event)\"\n    (change)=\"inputChange($event)\"\n    (blur)=\"inputBlur()\"\n  />\n  <button\n    class=\"bm-button bm-button--primary bm-input-search__search-button\"\n    (click)=\"search.emit(input.value)\"\n  >\n    <i class=\"fas fa-search\" aria-hidden=\"true\"></i>\n  </button>\n</div>\n\n<div class=\"bm-input-search__suggestions-container\" *ngIf=\"showSuggestions\">\n  <ul class=\"bm-input-search__suggestions-list\">\n    <li\n      i18n\n      tabindex=\"-1\"\n      *ngIf=\"filteredSuggestions?.length === 0\"\n      class=\"bm-input-search__suggestions-list-item\"\n    >\n      No matches found\n    </li>\n    <li\n      #sugg\n      tabindex=\"0\"\n      *ngFor=\"let suggestion of filteredSuggestions; let i = index\"\n      class=\"bm-input-search__suggestions-list-item\"\n      (click)=\"setInput(suggestion)\"\n      (keydown)=\"suggestionKeyUp($event, i, suggestion)\"\n    >\n      {{ suggestion }}\n    </li>\n  </ul>\n</div>\n",
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            // tslint:disable-next-line:no-forward-ref
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BMInputSearchComponent; })),
                            multi: true,
                        },
                    ],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    styles: ["bm-input-search{display:inline-block;position:relative}.bm-input-search__input{padding:.3rem 3rem .3rem 1rem!important;width:100%;box-sizing:border-box}.bm-input-search__input-container{position:relative;width:100%;height:100%}.bm-input-search__search-button{display:block;position:absolute;right:0;top:1px;bottom:1px;border-top-left-radius:0;border-bottom-left-radius:0;padding:0 .75em;font-weight:400}.bm-input-search--inverse .bm-input-search__input{background-color:#fff}.bm-input-search__suggestions-container{position:absolute;top:2.4em;width:100%;max-height:10em;box-shadow:0 0 4px 0 rgba(0,0,0,.09);overflow-x:auto}.bm-input-search__suggestions-list{list-style:none;padding:0;margin:0}.bm-input-search__suggestions-list-item{padding:.2em 1em;cursor:pointer}.bm-input-search__suggestions-list-item:nth-child(odd){background-color:#fff}.bm-input-search__suggestions-list-item:nth-child(even){background-color:var(--secondary-color,#bcbcbc)}.bm-input-search__suggestions-list-item:focus,.bm-input-search__suggestions-list-item:hover{background-color:var(--secondary-color-hover,#959494)}"]
                }] }
    ];
    /** @nocollapse */
    BMInputSearchComponent.ctorParameters = function () { return [
        { type: Renderer2 }
    ]; };
    BMInputSearchComponent.propDecorators = {
        input: [{ type: ViewChild, args: ['input', { static: true },] }],
        suggestionList: [{ type: ViewChildren, args: ['sugg',] }],
        name: [{ type: Input }],
        placeholder: [{ type: Input }],
        tabIndex: [{ type: Input }],
        required: [{ type: Input }],
        disabled: [{ type: Input }],
        readonly: [{ type: Input }],
        type: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        value: [{ type: Input }],
        minSuggestionChars: [{ type: Input }],
        suggestions: [{ type: Input }],
        search: [{ type: Output }]
    };
    return BMInputSearchComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BMOptionDirective = /** @class */ (function () {
    function BMOptionDirective() {
    }
    BMOptionDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[bmOption]',
                },] }
    ];
    return BMOptionDirective;
}());
var BMSelectComponent = /** @class */ (function () {
    function BMSelectComponent(_renderer) {
        this._renderer = _renderer;
        /**
         * Input values to directly copy to inner checkbox
         */
        this.name = '';
        this.tabIndex = 0;
        // tslint:disable-next-line:no-reserved-keywords
        this.type = 'text';
        // tslint:disable-next-line:no-any no-empty
        this.onTouched = (/**
         * @return {?}
         */
        function () { });
        // tslint:disable:no-any
        // tslint:disable:no-empty
        this.propagateChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
    }
    Object.defineProperty(BMSelectComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this._valueCopy;
        },
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            this._valueCopy = v;
            this.setCheckedOption();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Custom Input functions
     */
    /**
     * Custom Input functions
     * @return {?}
     */
    BMSelectComponent.prototype.inputBlur = /**
     * Custom Input functions
     * @return {?}
     */
    function () {
        this.onTouched();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    BMSelectComponent.prototype.writeValue = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._valueCopy = value;
        this.setCheckedOption();
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMSelectComponent.prototype.registerOnChange = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.propagateChange = fn;
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    BMSelectComponent.prototype.registerOnTouched = 
    // tslint:disable-next-line:no-any
    /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BMSelectComponent.prototype.inputChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        var value = (/** @type {?} */ (event.target)).value;
        this._valueCopy = value;
        this.propagateChange(value);
    };
    /**
     * @return {?}
     */
    BMSelectComponent.prototype.focus = /**
     * @return {?}
     */
    function () {
        ((/** @type {?} */ (this.select.nativeElement))).focus();
    };
    /**
     * @return {?}
     */
    BMSelectComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._optionsSubs = this.options.changes.subscribe((/**
         * @return {?}
         */
        function () {
            return _this.setCheckedOption();
        }));
        this.setCheckedOption();
    };
    /**
     * @return {?}
     */
    BMSelectComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this._optionsSubs) {
            this._optionsSubs.unsubscribe();
        }
    };
    /**
     * @private
     * @return {?}
     */
    BMSelectComponent.prototype.setCheckedOption = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this._valueCopy !== undefined) {
            this._renderer.setValue(this.select.nativeElement, this._valueCopy);
        }
        if (!this.options) {
            return;
        }
        this.options.forEach((/**
         * @param {?} elem
         * @return {?}
         */
        function (elem) {
            /** @type {?} */
            var domEle = elem.nativeElement;
            if (domEle) {
                domEle.selected = domEle.value === _this._valueCopy;
            }
        }));
    };
    BMSelectComponent.decorators = [
        { type: Component, args: [{
                    selector: 'bm-select',
                    template: "<select #select\n  class=\"bm-select__select\"\n  [required]=\"required\"\n  [disabled]=\"disabled\"\n  [name]=\"name\"\n  [tabIndex]=\"tabIndex\"\n  [attr.aria-label]=\"ariaLabel\"\n  [attr.aria-labelledby]=\"ariaLabelledby\"\n  (change)=\"inputChange($event)\"\n  (blur)=\"inputBlur()\">\n  <ng-content></ng-content>\n</select>\n",
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            // tslint:disable-next-line:no-forward-ref
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BMSelectComponent; })),
                            multi: true,
                        },
                    ],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    styles: [".bm-select__select{-moz-appearance:none;-ms-word-break:normal;-webkit-appearance:none;appearance:none;background:var(--header-color,#f8f8f8);border-radius:.333em;border:none;box-shadow:0 1px 1px 0 rgba(0,0,0,.2);font-family:proxima-regular;font-size:.815rem;font-weight:400;line-height:1.45rem;padding:.3em 2em .3em .6em;width:100%;word-break:normal}bm-select{min-width:200;display:inline-block;position:relative}bm-select--inverse .bm-select__select{background:#fff;box-shadow:inset 0 1px 1px 0 rgba(0,0,0,.2)}bm-select::after{content:'\\f0d7';font-weight:900;font-family:\"Font Awesome 5 Free\";pointer-events:none;position:absolute;right:8px;top:6px}"]
                }] }
    ];
    /** @nocollapse */
    BMSelectComponent.ctorParameters = function () { return [
        { type: Renderer2 }
    ]; };
    BMSelectComponent.propDecorators = {
        select: [{ type: ViewChild, args: ['select', { static: true },] }],
        options: [{ type: ContentChildren, args: [BMOptionDirective, { read: ElementRef },] }],
        name: [{ type: Input }],
        tabIndex: [{ type: Input }],
        required: [{ type: Input }],
        disabled: [{ type: Input }],
        readonly: [{ type: Input }],
        type: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        value: [{ type: Input }]
    };
    return BMSelectComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BMATFormsModule = /** @class */ (function () {
    function BMATFormsModule() {
    }
    BMATFormsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [
                        BMDurationInputComponent,
                        BMInputSearchComponent,
                        BMMultiselectComponent,
                        BMOptionDirective,
                        BMSelectComponent,
                    ],
                    exports: [
                        BMDurationInputComponent,
                        BMInputSearchComponent,
                        BMMultiselectComponent,
                        BMOptionDirective,
                        BMSelectComponent,
                    ],
                    providers: [],
                },] }
    ];
    return BMATFormsModule;
}());

export { BMATFormsModule, BMDurationInputComponent, BMInputSearchComponent, BMMultiselectComponent, BMOptionDirective, BMSelectComponent };
//# sourceMappingURL=bmat-angular-forms.js.map
