/**
 * Angular Component. Checkbox with BMAT Style
 */
import { ChangeDetectorRef, ElementRef, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export interface CheckboxChangeEvent {
    source: CheckboxComponent;
    checked: boolean;
}
export declare class CheckboxComponent implements ControlValueAccessor {
    private _renderer;
    private _changeDetectorRef;
    input: ElementRef;
    readonly isFocused: boolean;
    /**
     * Input values to directly copy to inner checkbox
     */
    name: string;
    tabIndex: number;
    required: boolean;
    disabled: boolean;
    readonly: boolean;
    ariaLabel: string;
    ariaLabelledby: string;
    checked: boolean;
    private _focused;
    private _onChangeCb;
    private _onTouchedCb;
    constructor(_renderer: Renderer2, _changeDetectorRef: ChangeDetectorRef);
    inputFocus(): void;
    inputBlur(): void;
    writeValue(value: boolean): void;
    registerOnChange(fn: (_: boolean) => void): void;
    registerOnTouched(fn: () => void): void;
    inputChange(event: Event): void;
    focus(): void;
}
