/**
 * Angular Component. Checkbox with BMAT Style
 */
import { ChangeDetectorRef, ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export interface BMSwitchCheckboxChangeEvent {
    source: BMSwitchCheckboxComponent;
    checked: boolean;
}
export declare class BMSwitchCheckboxComponent implements ControlValueAccessor {
    private _changeDetectorRef;
    private _renderer;
    input: ElementRef<HTMLInputElement>;
    readonly isFocused: boolean;
    /**
     * Input values to directly copy to inner checkbox
     */
    ariaLabel: string;
    ariaLabelledby: string;
    disabled: boolean;
    name: string;
    readonly: boolean;
    required: boolean;
    tabIndex: number;
    checked: boolean;
    switchChange: EventEmitter<BMSwitchCheckboxChangeEvent>;
    private _focused;
    private _propagateChange;
    private _onTouched;
    constructor(_changeDetectorRef: ChangeDetectorRef, _renderer: Renderer2);
    inputFocus(): void;
    inputBlur(): void;
    writeValue(value: boolean): void;
    registerOnChange(fn: (_: boolean) => {}): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    inputChange(event: Event): void;
    focus(): void;
}
