import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Zone } from 'luxon';
import { OwlDateTimeComponent } from 'ng-pick-datetime';
import { BehaviorSubject } from 'rxjs';
export interface DateTimeChangeEvent {
    input: HTMLInputElement;
    source: OwlDateTimeComponent<Date>;
    value: Date;
}
export declare type InnerValue = Date | null;
export declare class MomentInBoundComponent implements ControlValueAccessor {
    innerValue$: BehaviorSubject<InnerValue>;
    value: string;
    ariaLabel: string;
    ariaLabelledby: string;
    disabled: boolean;
    name: string;
    readonly: boolean;
    required: string;
    timezone: string | Zone;
    startTime: string;
    endTime: string;
    /**
     * Emit a RFC 3339 Datetime string
     */
    momentSelect: EventEmitter<string | null>;
    firstDayOfWeek: number;
    calendarMin: Date;
    calendarMax: Date;
    private _onChangeCb;
    private _onTouchedCb;
    constructor(locale: string);
    onDateTimeChange(e: DateTimeChangeEvent): void;
    writeValue(v: string): void;
    registerOnChange(fn: (_: string | null) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(disabled: boolean): void;
    onFocusin(): void;
}
