/**
 * Angular Component BMFileUploader
 * Drag & Drop File uploader
 */
import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { UploadEventsService } from '../upload-events-service/upload-events-service';
import { FileUploaderFile, FileUploaderUploadEvent, ValidDataTypes } from '../uploaders.interfaces';
export declare class BMFileUploaderComponent implements OnInit, OnDestroy, ControlValueAccessor {
    private _uploadEventsService;
    accept: string;
    dataType: ValidDataTypes;
    disabled: boolean;
    multiple: boolean;
    abort: EventEmitter<FileUploaderUploadEvent>;
    done: EventEmitter<FileUploaderUploadEvent>;
    empty: EventEmitter<FileUploaderUploadEvent>;
    error: EventEmitter<FileUploaderUploadEvent>;
    loading: EventEmitter<FileUploaderUploadEvent>;
    multipleInt: number;
    private _subs;
    private _onChangeCb;
    private _onTouchedCb;
    constructor(_uploadEventsService: UploadEventsService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFocusin(): void;
    writeValue(val: FileList | unknown): void;
    registerOnChange(fn: (_: FileUploaderFile[]) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
}
