/**
 * Module interfaces
 */
export declare const enum FileStatus {
    EMPTY = 0,
    LOADING = 1,
    DONE = 2,
    ERROR = 3,
    ABORT = 4
}
export declare const enum ValidDataTypes {
    ArrayBuffer = 0,
    DataURL = 1,
    Text = 2,
    /**
     * Do not parse the file, just send the File pointer
     */
    None = 3
}
export interface FileUploaderFile {
    data: null | ArrayBuffer | string | File;
    loaded: number;
    name: string;
    readonly lastModified?: number;
    size: number;
    total: number;
    type: string;
}
export interface UploadEvent {
    file: FileUploaderFile;
    reader: FileReader | null;
    status: FileStatus;
}
/**
 * Abstraction over the File ProgressEvent
 */
export interface FileUploaderUploadEvent {
    files: UploadEvent[];
    status: FileStatus;
    error: string | null;
}
