import { Overlay } from '@angular/cdk/overlay';
import { ElementRef, Injector } from '@angular/core';
import { Observable } from 'rxjs';
export declare enum PlayerType {
    Audio = 0,
    Video = 1
}
export interface OpenPlayerOptions {
    playerType: PlayerType;
    volume: number;
}
export declare enum ConnectedPlayerEventTypes {
    OPEN = "OPEN",
    CLOSE = "CLOSE"
}
export interface ConnectedPlayerEvent {
    kind: ConnectedPlayerEventTypes;
    source: ElementRef | HTMLElement | null;
}
export declare class ConnectedMediaRemoteService {
    private _injector;
    private _overlay;
    private _overlayRef;
    private _playerEventsSubject;
    constructor(_injector: Injector, _overlay: Overlay);
    getEvents(): Observable<ConnectedPlayerEvent>;
    open(src: string, host: ElementRef | HTMLElement | null, options?: Partial<OpenPlayerOptions>): void;
    isOpen(): boolean;
    close(): void;
    private setUpAudioPlayer;
    private setUpVideoPlayer;
}
